_GSM2_Initialize:
;App.c,51 :: 		void GSM2_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;App.c,53 :: 		GPIO_Clk_Enable(&GPIOA_BASE);                          // Enable clock on port A
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_GPIO_Clk_Enable+0
;App.c,54 :: 		GPIO_Clk_Enable(&GPIOB_BASE);                          // Enable clock on port B
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Clk_Enable+0
;App.c,55 :: 		GPIO_Clk_Enable(&GPIOD_BASE);                          // Enable clock on port D
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Clk_Enable+0
;App.c,56 :: 		GPIO_Clk_Enable(&GPIOE_BASE);                          // Enable clock on port E
MOVW	R0, #lo_addr(GPIOE_BASE+0)
MOVT	R0, #hi_addr(GPIOE_BASE+0)
BL	_GPIO_Clk_Enable+0
;App.c,58 :: 		GPIO_Digital_Input(&GPIOB_BASE,_GPIO_PINMASK_1);       // STAT is an input
MOVW	R1, #2
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;App.c,59 :: 		GPIO_Digital_Output(&GPIOB_BASE,_GPIO_PINMASK_12);     // PWRKEY is an output
MOVW	R1, #4096
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;App.c,60 :: 		GPIO_Digital_Output(&GPIOA_BASE,_GPIO_PINMASK_15);     // RTS is an output
MOVW	R1, #32768
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_GPIO_Digital_Output+0
;App.c,61 :: 		GPIO_Digital_Input(&GPIOD_BASE,_GPIO_PINMASK_14);      // RI is an input
MOVW	R1, #16384
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;App.c,62 :: 		GPIO_Digital_Input(&GPIOE_BASE,_GPIO_PINMASK_2);       // CTS is an input
MOVW	R1, #4
MOVW	R0, #lo_addr(GPIOE_BASE+0)
MOVT	R0, #hi_addr(GPIOE_BASE+0)
BL	_GPIO_Digital_Input+0
;App.c,64 :: 		GSM2_RTS = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOA_ODR+0)
MOVT	R0, #hi_addr(GPIOA_ODR+0)
STR	R1, [R0, #0]
;App.c,65 :: 		}
L_end_GSM2_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _GSM2_Initialize
_GSM2_KeyOn:
;App.c,69 :: 		void GSM2_KeyOn(void) {
;App.c,70 :: 		GSM2_PWRKEY = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
STR	R1, [R0, #0]
;App.c,71 :: 		}
L_end_GSM2_KeyOn:
BX	LR
; end of _GSM2_KeyOn
_GSM2_KeyOff:
;App.c,75 :: 		void GSM2_KeyOff(void) {
;App.c,76 :: 		GSM2_PWRKEY = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
STR	R1, [R0, #0]
;App.c,77 :: 		}
L_end_GSM2_KeyOff:
BX	LR
; end of _GSM2_KeyOff
_GSM2_RdStat:
;App.c,81 :: 		char GSM2_RdStat(void) {
;App.c,82 :: 		if (GSM2_STAT)
MOVW	R1, #lo_addr(GPIOB_IDR+0)
MOVT	R1, #hi_addr(GPIOB_IDR+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_GSM2_RdStat0
;App.c,83 :: 		return 1;
MOVS	R0, #1
IT	AL
BAL	L_end_GSM2_RdStat
L_GSM2_RdStat0:
;App.c,85 :: 		return 0;
MOVS	R0, #0
;App.c,86 :: 		}
L_end_GSM2_RdStat:
BX	LR
; end of _GSM2_RdStat
_WaitForResponse:
;App.c,90 :: 		short WaitForResponse(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;App.c,93 :: 		if (U2_MsgFlg) {
MOVW	R0, #lo_addr(_U2_MsgFlg+0)
MOVT	R0, #hi_addr(_U2_MsgFlg+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_WaitForResponse2
;App.c,94 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 8 (R2)
MOV	R2, R0
;App.c,95 :: 		strcpy(BufNum,U2_RcvBuf);
STR	R2, [SP, #4]
MOVW	R1, #lo_addr(_U2_RcvBuf+0)
MOVT	R1, #hi_addr(_U2_RcvBuf+0)
BL	_strcpy+0
LDR	R2, [SP, #4]
;App.c,96 :: 		U2_MsgFlg = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_U2_MsgFlg+0)
MOVT	R0, #hi_addr(_U2_MsgFlg+0)
STRB	R1, [R0, #0]
;App.c,98 :: 		UART6_PutQueue(BufNum);
STR	R2, [SP, #4]
MOV	R0, R2
BL	_UART6_PutQueue+0
LDR	R2, [SP, #4]
;App.c,100 :: 		if ((BufNum[0] == '\r') && (BufNum[1] == '\n')) {
LDRB	R0, [R2, #0]
CMP	R0, #13
IT	NE
BNE	L__WaitForResponse129
ADDS	R0, R2, #1
LDRB	R0, [R0, #0]
CMP	R0, #10
IT	NE
BNE	L__WaitForResponse128
; BufNum end address is: 8 (R2)
L__WaitForResponse127:
;App.c,102 :: 		return EMPTY;
MOVS	R0, #0
SXTB	R0, R0
IT	AL
BAL	L_end_WaitForResponse
;App.c,100 :: 		if ((BufNum[0] == '\r') && (BufNum[1] == '\n')) {
L__WaitForResponse129:
; BufNum start address is: 8 (R2)
L__WaitForResponse128:
;App.c,103 :: 		} else if ((BufNum[0] == 'O') && (BufNum[1] == 'K')) {
LDRB	R0, [R2, #0]
CMP	R0, #79
IT	NE
BNE	L__WaitForResponse131
ADDS	R0, R2, #1
LDRB	R0, [R0, #0]
CMP	R0, #75
IT	NE
BNE	L__WaitForResponse130
; BufNum end address is: 8 (R2)
L__WaitForResponse126:
;App.c,105 :: 		return OK;
MOVS	R0, #1
SXTB	R0, R0
IT	AL
BAL	L_end_WaitForResponse
;App.c,103 :: 		} else if ((BufNum[0] == 'O') && (BufNum[1] == 'K')) {
L__WaitForResponse131:
; BufNum start address is: 8 (R2)
L__WaitForResponse130:
;App.c,106 :: 		} else if ((BufNum[0] =='>') && (BufNum[1] == ' ')) {
LDRB	R0, [R2, #0]
CMP	R0, #62
IT	NE
BNE	L__WaitForResponse133
ADDS	R0, R2, #1
; BufNum end address is: 8 (R2)
LDRB	R0, [R0, #0]
CMP	R0, #32
IT	NE
BNE	L__WaitForResponse132
L__WaitForResponse125:
;App.c,107 :: 		return PROMPT;
MOVS	R0, #2
SXTB	R0, R0
IT	AL
BAL	L_end_WaitForResponse
;App.c,106 :: 		} else if ((BufNum[0] =='>') && (BufNum[1] == ' ')) {
L__WaitForResponse133:
L__WaitForResponse132:
;App.c,109 :: 		} else {
IT	AL
BAL	L_WaitForResponse14
L_WaitForResponse2:
;App.c,110 :: 		return NEG;
MOVS	R0, #-1
SXTB	R0, R0
IT	AL
BAL	L_end_WaitForResponse
;App.c,111 :: 		}
L_WaitForResponse14:
;App.c,112 :: 		}
L_end_WaitForResponse:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _WaitForResponse
_CheckTimeout:
;App.c,116 :: 		void CheckTimeout(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;App.c,117 :: 		if (check_timer(TimerHandle) == 0) {
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
BL	_check_timer+0
CMP	R0, #0
IT	NE
BNE	L_CheckTimeout15
;App.c,118 :: 		free_timer(TimerHandle);
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
BL	_free_timer+0
;App.c,119 :: 		UART6_PutQueue("Timeout\r\n");
MOVW	R0, #lo_addr(?lstr1_App+0)
MOVT	R0, #hi_addr(?lstr1_App+0)
BL	_UART6_PutQueue+0
;App.c,120 :: 		GSM2_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,121 :: 		}
L_CheckTimeout15:
;App.c,122 :: 		}
L_end_CheckTimeout:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _CheckTimeout
_GSM2_TaskMgr:
;App.c,128 :: 		void GSM2_TaskMgr(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;App.c,132 :: 		switch (GSM2_State) {
IT	AL
BAL	L_GSM2_TaskMgr16
;App.c,135 :: 		case 0:
L_GSM2_TaskMgr18:
;App.c,136 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,137 :: 		if (ResponseCode >= 0) {
CMP	R0, #0
IT	LT
BLT	L_GSM2_TaskMgr19
;App.c,138 :: 		if (ResponseCode == EMPTY) {
CMP	R1, #0
IT	NE
BNE	L_GSM2_TaskMgr20
; ResponseCode end address is: 4 (R1)
;App.c,140 :: 		} else if (ResponseCode == OK) {
IT	AL
BAL	L_GSM2_TaskMgr21
L_GSM2_TaskMgr20:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr22
; ResponseCode end address is: 4 (R1)
;App.c,142 :: 		}
L_GSM2_TaskMgr22:
L_GSM2_TaskMgr21:
;App.c,143 :: 		}
L_GSM2_TaskMgr19:
;App.c,144 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,149 :: 		case 1:   // Do hardware reset on GSM2 module
L_GSM2_TaskMgr23:
;App.c,150 :: 		GSM2_KeyOn();                   // Activate PWRKEY signal
BL	_GSM2_KeyOn+0
;App.c,151 :: 		TimerHandle = get_timer();      // Get a free timer
BL	_get_timer+0
MOVW	R1, #lo_addr(_TimerHandle+0)
MOVT	R1, #hi_addr(_TimerHandle+0)
STRB	R0, [R1, #0]
;App.c,152 :: 		GSM2_State = 2;
MOVS	R1, #2
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,153 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,154 :: 		case 2:
L_GSM2_TaskMgr24:
;App.c,155 :: 		if (GSM2_RdStat()) {            // Wait for hardware signal
BL	_GSM2_RdStat+0
CMP	R0, #0
IT	EQ
BEQ	L_GSM2_TaskMgr25
;App.c,156 :: 		set_timer(TimerHandle,100); // Delay an additional 100 ms
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVS	R1, #100
BL	_set_timer+0
;App.c,157 :: 		GSM2_State = 3;
MOVS	R1, #3
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,158 :: 		}
L_GSM2_TaskMgr25:
;App.c,159 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,160 :: 		case 3:
L_GSM2_TaskMgr26:
;App.c,161 :: 		if (check_timer(TimerHandle) == 0) {
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
BL	_check_timer+0
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr27
;App.c,162 :: 		free_timer(TimerHandle);    // Return timer to pool
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
BL	_free_timer+0
;App.c,163 :: 		GSM2_KeyOff();              // Deactivate PWRKEY signal
BL	_GSM2_KeyOff+0
;App.c,164 :: 		GSM2_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,165 :: 		}
L_GSM2_TaskMgr27:
;App.c,166 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,171 :: 		case 6:   // Set fixed baud rate to 9600
L_GSM2_TaskMgr28:
;App.c,172 :: 		UART2_PutQueue("AT+IPR=9600\r\n");
MOVW	R0, #lo_addr(?lstr2_App+0)
MOVT	R0, #hi_addr(?lstr2_App+0)
BL	_UART2_PutQueue+0
;App.c,173 :: 		GSM2_State = 7;
MOVS	R1, #7
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,174 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,175 :: 		case 7:
L_GSM2_TaskMgr29:
;App.c,176 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,177 :: 		if (ResponseCode == EMPTY) {
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr30
;App.c,178 :: 		}
L_GSM2_TaskMgr30:
;App.c,179 :: 		if (ResponseCode == OK) {
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr31
; ResponseCode end address is: 4 (R1)
;App.c,180 :: 		GSM2_State = 8;
MOVS	R1, #8
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,181 :: 		}
L_GSM2_TaskMgr31:
;App.c,182 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,183 :: 		case 8:
L_GSM2_TaskMgr32:
;App.c,184 :: 		UART2_PutQueue("AT&W\r\n");
MOVW	R0, #lo_addr(?lstr3_App+0)
MOVT	R0, #hi_addr(?lstr3_App+0)
BL	_UART2_PutQueue+0
;App.c,185 :: 		GSM2_State = 9;
MOVS	R1, #9
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,186 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,187 :: 		case 9:
L_GSM2_TaskMgr33:
;App.c,188 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,189 :: 		if (ResponseCode == EMPTY) {
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr34
;App.c,190 :: 		}
L_GSM2_TaskMgr34:
;App.c,191 :: 		if (ResponseCode == OK) {
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr35
; ResponseCode end address is: 4 (R1)
;App.c,192 :: 		GSM2_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,193 :: 		}
L_GSM2_TaskMgr35:
;App.c,194 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,199 :: 		case 10:  // Query the network state information
L_GSM2_TaskMgr36:
;App.c,200 :: 		TimerHandle = get_timer();
BL	_get_timer+0
MOVW	R1, #lo_addr(_TimerHandle+0)
MOVT	R1, #hi_addr(_TimerHandle+0)
STRB	R0, [R1, #0]
;App.c,201 :: 		set_timer(TimerHandle,5000);         // Timeout in 5 seconds
MOVW	R1, #5000
BL	_set_timer+0
;App.c,202 :: 		UART2_PutQueue("AT+CSQ\r\n");        // Query the signal strength of current network
MOVW	R0, #lo_addr(?lstr4_App+0)
MOVT	R0, #hi_addr(?lstr4_App+0)
BL	_UART2_PutQueue+0
;App.c,203 :: 		GSM2_State = 11;
MOVS	R1, #11
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,204 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,205 :: 		case 11:
L_GSM2_TaskMgr37:
;App.c,206 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,207 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr38
; ResponseCode end address is: 4 (R1)
;App.c,209 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr39
L_GSM2_TaskMgr38:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr40
; ResponseCode end address is: 4 (R1)
;App.c,210 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,211 :: 		UART2_PutQueue("AT+CREG?\r\n");  // Query register state of GSM network
MOVW	R0, #lo_addr(?lstr5_App+0)
MOVT	R0, #hi_addr(?lstr5_App+0)
BL	_UART2_PutQueue+0
;App.c,212 :: 		GSM2_State = 12;
MOVS	R1, #12
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,213 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr41
L_GSM2_TaskMgr40:
;App.c,214 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr41:
L_GSM2_TaskMgr39:
;App.c,215 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,216 :: 		case 12:
L_GSM2_TaskMgr42:
;App.c,217 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,218 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr43
; ResponseCode end address is: 4 (R1)
;App.c,220 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr44
L_GSM2_TaskMgr43:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr45
; ResponseCode end address is: 4 (R1)
;App.c,221 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,222 :: 		UART2_PutQueue("AT+CGREG?\r\n"); // Query register state of GPRS network
MOVW	R0, #lo_addr(?lstr6_App+0)
MOVT	R0, #hi_addr(?lstr6_App+0)
BL	_UART2_PutQueue+0
;App.c,223 :: 		GSM2_State = 13;
MOVS	R1, #13
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,224 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr46
L_GSM2_TaskMgr45:
;App.c,225 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr46:
L_GSM2_TaskMgr44:
;App.c,226 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,227 :: 		case 13:
L_GSM2_TaskMgr47:
;App.c,228 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,229 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr48
; ResponseCode end address is: 4 (R1)
;App.c,231 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr49
L_GSM2_TaskMgr48:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr50
; ResponseCode end address is: 4 (R1)
;App.c,232 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,233 :: 		UART2_PutQueue("AT+COPS?\r\n");  // Query the current selected operator
MOVW	R0, #lo_addr(?lstr7_App+0)
MOVT	R0, #hi_addr(?lstr7_App+0)
BL	_UART2_PutQueue+0
;App.c,234 :: 		GSM2_State = 14;
MOVS	R1, #14
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,235 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr51
L_GSM2_TaskMgr50:
;App.c,236 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr51:
L_GSM2_TaskMgr49:
;App.c,237 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,238 :: 		case 14:
L_GSM2_TaskMgr52:
;App.c,239 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,240 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr53
; ResponseCode end address is: 4 (R1)
;App.c,242 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr54
L_GSM2_TaskMgr53:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr55
; ResponseCode end address is: 4 (R1)
;App.c,243 :: 		free_timer(TimerHandle);         // Return timer to pool
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
BL	_free_timer+0
;App.c,244 :: 		GSM2_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,245 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr56
L_GSM2_TaskMgr55:
;App.c,246 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr56:
L_GSM2_TaskMgr54:
;App.c,247 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,252 :: 		case 20:   // Power down the module
L_GSM2_TaskMgr57:
;App.c,253 :: 		UART2_PutQueue("AT+QPOWD=1\r\n");
MOVW	R0, #lo_addr(?lstr8_App+0)
MOVT	R0, #hi_addr(?lstr8_App+0)
BL	_UART2_PutQueue+0
;App.c,254 :: 		GSM2_State = 21;
MOVS	R1, #21
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,255 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,256 :: 		case 21:
L_GSM2_TaskMgr58:
;App.c,257 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
;App.c,258 :: 		if (ResponseCode == EMPTY) {
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr59
;App.c,260 :: 		} else {
IT	AL
BAL	L_GSM2_TaskMgr60
L_GSM2_TaskMgr59:
;App.c,261 :: 		GSM2_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,262 :: 		}
L_GSM2_TaskMgr60:
;App.c,263 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,268 :: 		case 30:  // Send SMS in text mode
L_GSM2_TaskMgr61:
;App.c,269 :: 		TimerHandle = get_timer();
BL	_get_timer+0
MOVW	R1, #lo_addr(_TimerHandle+0)
MOVT	R1, #hi_addr(_TimerHandle+0)
STRB	R0, [R1, #0]
;App.c,270 :: 		set_timer(TimerHandle,5000);         // Timeout in 5 seconds
MOVW	R1, #5000
BL	_set_timer+0
;App.c,271 :: 		UART2_PutQueue("AT+CMGF=1\r\n");     // Set text mode
MOVW	R0, #lo_addr(?lstr9_App+0)
MOVT	R0, #hi_addr(?lstr9_App+0)
BL	_UART2_PutQueue+0
;App.c,272 :: 		GSM2_State = 31;
MOVS	R1, #31
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,273 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,274 :: 		case 31:
L_GSM2_TaskMgr62:
;App.c,275 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,276 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr63
; ResponseCode end address is: 4 (R1)
;App.c,278 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr64
L_GSM2_TaskMgr63:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr65
; ResponseCode end address is: 4 (R1)
;App.c,279 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,280 :: 		UART2_PutQueue("AT+CSCS=\"GSM\"\r\n");  // Set character set to "GSM"
MOVW	R0, #lo_addr(?lstr10_App+0)
MOVT	R0, #hi_addr(?lstr10_App+0)
BL	_UART2_PutQueue+0
;App.c,281 :: 		GSM2_State = 33;  // Skip next state
MOVS	R1, #33
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,282 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr66
L_GSM2_TaskMgr65:
;App.c,283 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr66:
L_GSM2_TaskMgr64:
;App.c,284 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,286 :: 		case 32:
L_GSM2_TaskMgr67:
;App.c,287 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,288 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr68
; ResponseCode end address is: 4 (R1)
;App.c,290 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr69
L_GSM2_TaskMgr68:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr70
; ResponseCode end address is: 4 (R1)
;App.c,291 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,292 :: 		UART2_PutQueue("ATE0\r\n");      // Disable echo
MOVW	R0, #lo_addr(?lstr11_App+0)
MOVT	R0, #hi_addr(?lstr11_App+0)
BL	_UART2_PutQueue+0
;App.c,293 :: 		GSM2_State = 33;
MOVS	R1, #33
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,294 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr71
L_GSM2_TaskMgr70:
;App.c,295 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr71:
L_GSM2_TaskMgr69:
;App.c,296 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,298 :: 		case 33:
L_GSM2_TaskMgr72:
;App.c,299 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,300 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr73
; ResponseCode end address is: 4 (R1)
;App.c,302 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr74
L_GSM2_TaskMgr73:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr75
; ResponseCode end address is: 4 (R1)
;App.c,303 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,304 :: 		UART2_PutQueue("AT+CMGS=\"+19052524261\"\r\n"); // Send SMS phone number
MOVW	R0, #lo_addr(?lstr12_App+0)
MOVT	R0, #hi_addr(?lstr12_App+0)
BL	_UART2_PutQueue+0
;App.c,305 :: 		GSM2_State = 34;
MOVS	R1, #34
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,306 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr76
L_GSM2_TaskMgr75:
;App.c,307 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr76:
L_GSM2_TaskMgr74:
;App.c,308 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,309 :: 		case 34:
L_GSM2_TaskMgr77:
;App.c,310 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,311 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr78
; ResponseCode end address is: 4 (R1)
;App.c,313 :: 		} else if (ResponseCode == PROMPT) { // OK response
IT	AL
BAL	L_GSM2_TaskMgr79
L_GSM2_TaskMgr78:
; ResponseCode start address is: 4 (R1)
CMP	R1, #2
IT	NE
BNE	L_GSM2_TaskMgr80
; ResponseCode end address is: 4 (R1)
;App.c,314 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,315 :: 		UART2_PutQueue("Hello world\r\n");
MOVW	R0, #lo_addr(?lstr13_App+0)
MOVT	R0, #hi_addr(?lstr13_App+0)
BL	_UART2_PutQueue+0
;App.c,316 :: 		GSM2_State = 35;
MOVS	R1, #35
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,317 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr81
L_GSM2_TaskMgr80:
;App.c,318 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr81:
L_GSM2_TaskMgr79:
;App.c,319 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,320 :: 		case 35:
L_GSM2_TaskMgr82:
;App.c,321 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,322 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr83
; ResponseCode end address is: 4 (R1)
;App.c,324 :: 		} else if (ResponseCode == PROMPT) { // OK response
IT	AL
BAL	L_GSM2_TaskMgr84
L_GSM2_TaskMgr83:
; ResponseCode start address is: 4 (R1)
CMP	R1, #2
IT	NE
BNE	L_GSM2_TaskMgr85
; ResponseCode end address is: 4 (R1)
;App.c,325 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,326 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 8 (R2)
MOV	R2, R0
;App.c,327 :: 		BufNum[0] = 0x1A;                // CTRL+Z
MOVS	R1, #26
STRB	R1, [R0, #0]
;App.c,328 :: 		BufNum[1] = 0x0D;                // CR
ADDS	R1, R2, #1
MOVS	R0, #13
STRB	R0, [R1, #0]
;App.c,329 :: 		BufNum[2] = 0x00;                // NULL
ADDS	R1, R2, #2
MOVS	R0, #0
STRB	R0, [R1, #0]
;App.c,331 :: 		UART2_PutQueue(BufNum);
MOV	R0, R2
; BufNum end address is: 8 (R2)
BL	_UART2_PutQueue+0
;App.c,332 :: 		GSM2_State = 37; // Skip next state
MOVS	R1, #37
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,333 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr86
L_GSM2_TaskMgr85:
;App.c,334 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr86:
L_GSM2_TaskMgr84:
;App.c,335 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,337 :: 		case 36:
L_GSM2_TaskMgr87:
;App.c,338 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,339 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr88
; ResponseCode end address is: 4 (R1)
;App.c,341 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr89
L_GSM2_TaskMgr88:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr90
; ResponseCode end address is: 4 (R1)
;App.c,342 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,343 :: 		UART2_PutQueue("ATE1\r\n");      // Enable echo
MOVW	R0, #lo_addr(?lstr14_App+0)
MOVT	R0, #hi_addr(?lstr14_App+0)
BL	_UART2_PutQueue+0
;App.c,344 :: 		GSM2_State = 37;
MOVS	R1, #37
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,345 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr91
L_GSM2_TaskMgr90:
;App.c,346 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr91:
L_GSM2_TaskMgr89:
;App.c,347 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,349 :: 		case 37:
L_GSM2_TaskMgr92:
;App.c,350 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,351 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr93
; ResponseCode end address is: 4 (R1)
;App.c,353 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr94
L_GSM2_TaskMgr93:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr95
; ResponseCode end address is: 4 (R1)
;App.c,354 :: 		free_timer(TimerHandle);         // Return timer to pool
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
BL	_free_timer+0
;App.c,355 :: 		GSM2_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,356 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr96
L_GSM2_TaskMgr95:
;App.c,357 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr96:
L_GSM2_TaskMgr94:
;App.c,358 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,363 :: 		case 40:  // Delete SMS messages 1, 2, and 3
L_GSM2_TaskMgr97:
;App.c,364 :: 		TimerHandle = get_timer();
BL	_get_timer+0
MOVW	R1, #lo_addr(_TimerHandle+0)
MOVT	R1, #hi_addr(_TimerHandle+0)
STRB	R0, [R1, #0]
;App.c,365 :: 		set_timer(TimerHandle,5000);         // Timeout in 5 seconds
MOVW	R1, #5000
BL	_set_timer+0
;App.c,366 :: 		UART2_PutQueue("AT+CMGF=1\r\n");     // Set text mode
MOVW	R0, #lo_addr(?lstr15_App+0)
MOVT	R0, #hi_addr(?lstr15_App+0)
BL	_UART2_PutQueue+0
;App.c,367 :: 		GSM2_State = 41;
MOVS	R1, #41
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,368 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,369 :: 		case 41:
L_GSM2_TaskMgr98:
;App.c,370 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,371 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr99
; ResponseCode end address is: 4 (R1)
;App.c,373 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr100
L_GSM2_TaskMgr99:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr101
; ResponseCode end address is: 4 (R1)
;App.c,374 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,375 :: 		UART2_PutQueue("AT+CSCS=\"GSM\"\r\n");  // Set character set to "GSM"
MOVW	R0, #lo_addr(?lstr16_App+0)
MOVT	R0, #hi_addr(?lstr16_App+0)
BL	_UART2_PutQueue+0
;App.c,376 :: 		GSM2_State = 42;
MOVS	R1, #42
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,377 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr102
L_GSM2_TaskMgr101:
;App.c,378 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr102:
L_GSM2_TaskMgr100:
;App.c,379 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,380 :: 		case 42:
L_GSM2_TaskMgr103:
;App.c,381 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,382 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr104
; ResponseCode end address is: 4 (R1)
;App.c,384 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr105
L_GSM2_TaskMgr104:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr106
; ResponseCode end address is: 4 (R1)
;App.c,385 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,386 :: 		UART2_PutQueue("AT+CMGD=1\r\n");     // Delete SMS message 1
MOVW	R0, #lo_addr(?lstr17_App+0)
MOVT	R0, #hi_addr(?lstr17_App+0)
BL	_UART2_PutQueue+0
;App.c,387 :: 		GSM2_State = 43;
MOVS	R1, #43
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,388 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr107
L_GSM2_TaskMgr106:
;App.c,389 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr107:
L_GSM2_TaskMgr105:
;App.c,390 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,391 :: 		case 43:
L_GSM2_TaskMgr108:
;App.c,392 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,393 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr109
; ResponseCode end address is: 4 (R1)
;App.c,395 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr110
L_GSM2_TaskMgr109:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr111
; ResponseCode end address is: 4 (R1)
;App.c,396 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,397 :: 		UART2_PutQueue("AT+CMGD=2\r\n");     // Delete SMS message 2
MOVW	R0, #lo_addr(?lstr18_App+0)
MOVT	R0, #hi_addr(?lstr18_App+0)
BL	_UART2_PutQueue+0
;App.c,398 :: 		GSM2_State = 44;
MOVS	R1, #44
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,399 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr112
L_GSM2_TaskMgr111:
;App.c,400 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr112:
L_GSM2_TaskMgr110:
;App.c,401 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,402 :: 		case 44:
L_GSM2_TaskMgr113:
;App.c,403 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,404 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr114
; ResponseCode end address is: 4 (R1)
;App.c,406 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr115
L_GSM2_TaskMgr114:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr116
; ResponseCode end address is: 4 (R1)
;App.c,407 :: 		set_timer(TimerHandle,5000);     // Reset timer
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;App.c,408 :: 		UART2_PutQueue("AT+CMGD=3\r\n");     // Delete SMS message 3
MOVW	R0, #lo_addr(?lstr19_App+0)
MOVT	R0, #hi_addr(?lstr19_App+0)
BL	_UART2_PutQueue+0
;App.c,409 :: 		GSM2_State = 45;
MOVS	R1, #45
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,410 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr117
L_GSM2_TaskMgr116:
;App.c,411 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr117:
L_GSM2_TaskMgr115:
;App.c,412 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,413 :: 		case 45:
L_GSM2_TaskMgr118:
;App.c,414 :: 		ResponseCode = WaitForResponse();
BL	_WaitForResponse+0
; ResponseCode start address is: 4 (R1)
SXTB	R1, R0
;App.c,415 :: 		if (ResponseCode == EMPTY) {         // Blank line
CMP	R0, #0
IT	NE
BNE	L_GSM2_TaskMgr119
; ResponseCode end address is: 4 (R1)
;App.c,417 :: 		} else if (ResponseCode == OK) {     // OK response
IT	AL
BAL	L_GSM2_TaskMgr120
L_GSM2_TaskMgr119:
; ResponseCode start address is: 4 (R1)
CMP	R1, #1
IT	NE
BNE	L_GSM2_TaskMgr121
; ResponseCode end address is: 4 (R1)
;App.c,418 :: 		free_timer(TimerHandle);         // Return timer to pool
MOVW	R0, #lo_addr(_TimerHandle+0)
MOVT	R0, #hi_addr(_TimerHandle+0)
LDRB	R0, [R0, #0]
BL	_free_timer+0
;App.c,419 :: 		GSM2_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
STRB	R1, [R0, #0]
;App.c,420 :: 		} else
IT	AL
BAL	L_GSM2_TaskMgr122
L_GSM2_TaskMgr121:
;App.c,421 :: 		CheckTimeout();
BL	_CheckTimeout+0
L_GSM2_TaskMgr122:
L_GSM2_TaskMgr120:
;App.c,422 :: 		break;
IT	AL
BAL	L_GSM2_TaskMgr17
;App.c,423 :: 		}
L_GSM2_TaskMgr16:
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_GSM2_TaskMgr18
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_GSM2_TaskMgr23
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	EQ
BEQ	L_GSM2_TaskMgr24
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #3
IT	EQ
BEQ	L_GSM2_TaskMgr26
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #6
IT	EQ
BEQ	L_GSM2_TaskMgr28
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #7
IT	EQ
BEQ	L_GSM2_TaskMgr29
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #8
IT	EQ
BEQ	L_GSM2_TaskMgr32
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #9
IT	EQ
BEQ	L_GSM2_TaskMgr33
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #10
IT	EQ
BEQ	L_GSM2_TaskMgr36
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #11
IT	EQ
BEQ	L_GSM2_TaskMgr37
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #12
IT	EQ
BEQ	L_GSM2_TaskMgr42
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #13
IT	EQ
BEQ	L_GSM2_TaskMgr47
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #14
IT	EQ
BEQ	L_GSM2_TaskMgr52
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #20
IT	EQ
BEQ	L_GSM2_TaskMgr57
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #21
IT	EQ
BEQ	L_GSM2_TaskMgr58
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #30
IT	EQ
BEQ	L_GSM2_TaskMgr61
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #31
IT	EQ
BEQ	L_GSM2_TaskMgr62
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #32
IT	EQ
BEQ	L_GSM2_TaskMgr67
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #33
IT	EQ
BEQ	L_GSM2_TaskMgr72
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #34
IT	EQ
BEQ	L_GSM2_TaskMgr77
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #35
IT	EQ
BEQ	L_GSM2_TaskMgr82
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #36
IT	EQ
BEQ	L_GSM2_TaskMgr87
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #37
IT	EQ
BEQ	L_GSM2_TaskMgr92
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #40
IT	EQ
BEQ	L_GSM2_TaskMgr97
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #41
IT	EQ
BEQ	L_GSM2_TaskMgr98
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #42
IT	EQ
BEQ	L_GSM2_TaskMgr103
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #43
IT	EQ
BEQ	L_GSM2_TaskMgr108
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #44
IT	EQ
BEQ	L_GSM2_TaskMgr113
MOVW	R0, #lo_addr(_GSM2_State+0)
MOVT	R0, #hi_addr(_GSM2_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #45
IT	EQ
BEQ	L_GSM2_TaskMgr118
L_GSM2_TaskMgr17:
;App.c,424 :: 		}
L_end_GSM2_TaskMgr:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _GSM2_TaskMgr
_GetToken:
;App.c,433 :: 		short GetToken(char *s, char *t) {
; t start address is: 4 (R1)
SUB	SP, SP, #8
STR	LR, [SP, #0]
MOV	R6, R0
MOV	R8, R1
; t end address is: 4 (R1)
; s start address is: 24 (R6)
; t start address is: 32 (R8)
;App.c,436 :: 		if (strlen(s) == 0) {          // If the string is empty
MOV	R0, R6
BL	_strlen+0
CMP	R0, #0
IT	NE
BNE	L_GetToken123
; s end address is: 24 (R6)
; t end address is: 32 (R8)
;App.c,437 :: 		return (-1);
MOVS	R0, #-1
SXTB	R0, R0
IT	AL
BAL	L_end_GetToken
;App.c,438 :: 		}
L_GetToken123:
;App.c,439 :: 		p = strchr(s,',');             // Find location of comma
; t start address is: 32 (R8)
; s start address is: 24 (R6)
MOVS	R1, #44
MOV	R0, R6
BL	_strchr+0
; p start address is: 28 (R7)
MOV	R7, R0
;App.c,440 :: 		if (p == NUL) {                // If didn't find a comma
CMP	R0, #0
IT	NE
BNE	L_GetToken124
; p end address is: 28 (R7)
;App.c,441 :: 		strcpy(t,s);               // Copy the final token
MOV	R1, R6
MOV	R0, R8
; t end address is: 32 (R8)
BL	_strcpy+0
;App.c,442 :: 		strcpy(s,"");              // Nullify the input string
MOVW	R2, #lo_addr(?lstr20_App+0)
MOVT	R2, #hi_addr(?lstr20_App+0)
MOV	R1, R2
MOV	R0, R6
; s end address is: 24 (R6)
BL	_strcpy+0
;App.c,443 :: 		return 0;
MOVS	R0, #0
SXTB	R0, R0
IT	AL
BAL	L_end_GetToken
;App.c,444 :: 		}
L_GetToken124:
;App.c,445 :: 		s[strlen(s)-strlen(p)] = '\0'; // Replace the comma with a null
; p start address is: 28 (R7)
; t start address is: 32 (R8)
; s start address is: 24 (R6)
MOV	R0, R6
BL	_strlen+0
STRH	R0, [SP, #4]
MOV	R0, R7
BL	_strlen+0
LDRSH	R2, [SP, #4]
SUB	R2, R2, R0
SXTH	R2, R2
ADDS	R3, R6, R2
MOVS	R2, #0
STRB	R2, [R3, #0]
;App.c,446 :: 		strcpy(t,s);                   // Copy the token
MOV	R1, R6
MOV	R0, R8
; t end address is: 32 (R8)
BL	_strcpy+0
;App.c,447 :: 		p++;                           // Advance the pointer to the next character position
ADDS	R2, R7, #1
; p end address is: 28 (R7)
;App.c,448 :: 		strcpy(s,p);                   // Overlay the input string minus the first token
MOV	R1, R2
MOV	R0, R6
; s end address is: 24 (R6)
BL	_strcpy+0
;App.c,449 :: 		return 1;
MOVS	R0, #1
SXTB	R0, R0
;App.c,450 :: 		}
L_end_GetToken:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _GetToken
