/**************************************************************************************************
  Common.h
  Some common definitions.
**************************************************************************************************/
#ifndef COMMON_H
#define COMMON_H


// Defines

#define FALSE 0
#define TRUE 1


#define DEBUG 0          // Set to 0 to prevent diagnostic messages on UART1

// UART1 not used on this microprocessor
#if DEBUG == 1
#define DEBUGOUT(c) UART1_PutQueue(c)
#else
#define DEBUGOUT(c) {}
#endif

#define USB_DEBUG 1      // Set to 0 to prevent diagnostic messages on USB

#if USB_DEBUG == 1
#define USB_DEBUGOUT(c) USB_PutQueue(c)
#else
#define USB_DEBUGOUT(c) {}
#endif


#define UseMikroE 0


#endif