#line 1 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
#line 9 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void TimerInit();
void TimerCheck();
#line 31 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void init_timerpool(void);
#line 52 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void irqhandler_timer(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/common.h"
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
#line 20 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 11 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
int TimerFlag = 0;
unsigned int Msec = 0;
#line 22 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
void SystemTimerInterrupt() iv IVT_INT_SysTick ics ICS_AUTO {
 if (COUNTFLAG_bit) {
 irqhandler_timer();

 Msec += 1;
 if (Msec > 999) {
 Msec = 0;
 TimerFlag = 1;
 }
 }
}
#line 36 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
void TimerInit() {
 init_timerpool();

 NVIC_SYSTICKRVR = 18750;
 NVIC_SYSTICKCVR = 0;
 ENABLE_SYSTICKCSR_bit = 1;
 TICKINT_bit = 1;
}
#line 47 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
void TimerCheck() {
 if (TimerFlag == 1) {
 TimerFlag = 0;

 }
}
#line 74 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
struct timers TimerPool[ 10 ];
#line 83 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
void init_timerpool(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 TimerPool[i].TimerField = 0;
 TimerPool[i].Free =  1 ;
 }
}
#line 98 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
unsigned short int get_timer(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 if (TimerPool[i].Free ==  1 ) {
 TimerPool[i].Free =  0 ;
 return i;
 }
 }




 return (0);
}
#line 120 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
void free_timer(unsigned short int nbr) {
 if (nbr > ( 10 -1))
 return;

 TimerPool[nbr].Free =  1 ;
}
#line 134 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
void set_timer(unsigned short int nbr, unsigned long int tout) {
 if (nbr > ( 10 -1))
 return;

 if (TimerPool[nbr].Free ==  1 )
 return;

 TimerPool[nbr].TimerField = tout;
}
#line 150 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
unsigned long int check_timer(unsigned short int nbr) {
 return TimerPool[nbr].TimerField;
}
#line 160 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/Timers.c"
void irqhandler_timer(void) {
 unsigned short int i;

 for (i=0; i< 10 ; i++) {
 if (TimerPool[i].Free ==  0  && TimerPool[i].TimerField != 0)
 TimerPool[i].TimerField--;
 }
}
