#line 1 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart2.h"
#line 21 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart2.h"
void UART2_SetBaud(void);
void UART2_StartRx(void);
void UART2_StartTx(void);

void UART2_Initialize(void);

void UART2_RxQueueInit(void);
char UART2_GetChar(char *rxbyte);

void UART2_Rx(void);
void UART2_Rx1(void);
void UART2_Rx2(void);


void UART2_TxQueueInit(void);
void UART2_PutQueue(char *msg);

void UART2_SendMsg(char *s);
void UART2_CheckQueue(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
#line 20 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/buffers.h"
#line 14 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
#pragma funcall UART2_Rx1, UART2_Rx2
#line 24 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
char U2_RxIn;
char U2_RxOut;
char U2_RxQueue[ 256 ];

char U2_RcvBuf[ 256 ];
char U2_RcvBufPtr;


char U2_TxIn;
char U2_TxOut;
char *U2_TxQueue[ 64 ];

char *U2_XmtBuf;
char U2_XmtBufPtr;



tPointerFcn UART2_RxFuncPtr = UART2_Rx1;
char U2_MsgFlg = 0;
char PromptFlag = 0;
#line 51 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_Interrupt() iv IVT_INT_USART2 ics ICS_AUTO {
 char R_data;
 char T_data;


 if ((RXNE_USART2_SR_bit) ) {
 R_data = USART2_DR;
 U2_RxQueue[U2_RxIn++] = R_data;
 if (U2_RxIn > ( 256 -1))
 U2_RxIn = 0;
 }

 if ((TXE_USART2_SR_bit)&&(TXEIE_USART2_CR1_bit)) {
 T_data = U2_XmtBuf[U2_XmtBufPtr++];
 if (T_data ==  0x00 ) {
 TXEIE_USART2_CR1_bit = 0;
 } else {
 USART2_DR = T_data;
 }
 }
}
#line 75 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_SetBaud(void) {



 GPIOAEN_bit = 1;
 GPIODEN_bit = 1;

 GPIOA_MODER |= 0x00000080;
 GPIOD_MODER |= 0x00000800;

 GPIOA_AFRL |= 0x00007000;
 GPIOD_AFRL |= 0x00700000;

 USART2EN_bit = 1;
 USART2_CR1 = 0x200C;
 USART2_BRR = 0x0F42;

 NVIC_IntEnable(IVT_INT_USART2);
}
#line 97 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_StartRx(void) {
 RXNEIE_USART2_CR1_bit = 1;
}
#line 103 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_StartTx(void) {
 TXEIE_USART2_CR1_bit = 1;
}
#line 114 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_Initialize(void) {
 UART2_RxQueueInit();
 UART2_TxQueueInit();

 UART2_SetBaud();
 UART2_StartRx();
}
#line 125 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_RxQueueInit(void) {
 U2_RxIn = U2_RxOut = 0;
 U2_RcvBufPtr = 0;
}
#line 134 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
char UART2_GetChar(char *rxbyte) {
 if (U2_RxIn != U2_RxOut) {
 *rxbyte = U2_RxQueue[U2_RxOut++];
 if (U2_RxOut > ( 256 -1))
 U2_RxOut = 0;
 return 1;
 }else{
 return 0;
 }
}
#line 147 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_Rx(void) {
 UART2_RxFuncPtr();
}
#line 154 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_Rx1(void){
 char rxchar;

 if (UART2_GetChar(&rxchar)) {
 switch (rxchar) {
 case  0x00 :
 break;

 case '\r':
 U2_RcvBuf[U2_RcvBufPtr++] = rxchar;
 break;

 case '\n':
 U2_RcvBuf[U2_RcvBufPtr++] = rxchar;
 U2_RcvBuf[U2_RcvBufPtr] = 0;
 U2_RcvBufPtr = 0;

 U2_MsgFlg = 1;

 UART2_RxFuncPtr = UART2_Rx2;
 break;

 case '>':
 U2_RcvBuf[U2_RcvBufPtr++] = rxchar;
 PromptFlag = 1;
 break;

 case ' ':
 U2_RcvBuf[U2_RcvBufPtr++] = rxchar;
 if (PromptFlag == 1) {
 U2_RcvBuf[U2_RcvBufPtr] = 0;
 U2_RcvBufPtr = 0;
 U2_MsgFlg = 1;
 }
 PromptFlag = 0;
 break;

 default:
 if ((rxchar > 31) && (rxchar < 127)) {
 if (U2_RcvBufPtr < ( 256 -2))
 U2_RcvBuf[U2_RcvBufPtr++] = rxchar;
 }
 break;
 }
 }
}
#line 203 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_Rx2(void) {
 if (U2_MsgFlg == 0) {
 UART2_RxFuncPtr = UART2_Rx1;
 }
}
#line 214 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_TxQueueInit(void) {
 U2_TxIn = U2_TxOut = 0;
 U2_XmtBufPtr = 0;
}
#line 222 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_PutQueue(char *msg) {
 U2_TxQueue[U2_TxIn++] = msg;
 if (U2_TxIn > ( 64 -1))
 U2_TxIn = 0;
}
#line 230 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_SendMsg(char *s) {
 U2_XmtBuf = s;
 U2_XmtBufPtr = 0;
 UART2_StartTx();
}
#line 239 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART2.c"
void UART2_CheckQueue(void) {
 if (TXEIE_USART2_CR1_bit == 0) {
 if (U2_TxIn != U2_TxOut) {
 UART2_SendMsg(U2_TxQueue[U2_TxOut++]);
 if (U2_TxOut > ( 64 -1))
 U2_TxOut = 0;
 }
 }
}
