#line 1 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
#line 20 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart2.h"
#line 21 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart2.h"
void UART2_SetBaud(void);
void UART2_StartRx(void);
void UART2_StartTx(void);

void UART2_Initialize(void);

void UART2_RxQueueInit(void);
char UART2_GetChar(char *rxbyte);

void UART2_Rx(void);
void UART2_Rx1(void);
void UART2_Rx2(void);


void UART2_TxQueueInit(void);
void UART2_PutQueue(char *msg);

void UART2_SendMsg(char *s);
void UART2_CheckQueue(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/buffers.h"
#line 14 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/app.h"
#line 19 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/app.h"
void GSM2_Initialize(void);
void GSM2_KeyOn(void);
void GSM2_KeyOff(void);
char GSM2_RdStat(void);
short WaitForResponse(void);
void CheckTimeout(void);

void GSM2_TaskMgr(void);

short GetToken(char *s, char *t);
#pragma funcall UART6_Rx1, UART6_Rx2
#line 27 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
char RxIn;
char RxOut;
char RxQueue[ 256 ];

char RcvBuf[ 256 ];
char RcvBufPtr;


char TxIn;
char TxOut;
char *TxQueue[ 64 ];

char *XmtBuf;
char XmtBufPtr;



tPointerFcn UART6_RxFuncPtr = UART6_Rx1;
extern tPointerFcn Print_FuncPtr;
extern char I2C2_State;
extern char U2_MsgFlg;
extern char U2_RcvBuf[];
extern char GSM2_State;

char TestBuffer[32] = "one,two,three";
char Token[32];
#line 57 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_Interrupt() iv IVT_INT_USART6 ics ICS_AUTO {
 char R_data;
 char T_data;


 if ((RXNE_USART6_SR_bit) ) {
 R_data = USART6_DR;
 RxQueue[RxIn++] = R_data;
 if (RxIn > ( 256 -1))
 RxIn = 0;
 }

 if ((TXE_USART6_SR_bit)&&(TXEIE_USART6_CR1_bit)) {
 T_data = XmtBuf[XmtBufPtr++];
 if (T_data ==  0x00 ) {
 TXEIE_USART6_CR1_bit = 0;
 } else {
 USART6_DR = T_data;
 }
 }
}
#line 81 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_SetBaud(void) {

 GPIOCEN_bit = 1;

 GPIOC_MODER |= 0x0000A000;
 GPIOC_AFRL |= 0x88000000;

 USART6EN_bit = 1;
 USART6_CR1 |= 0x0000200C;
 USART6_BRR = 0x00001E84;

 NVIC_IntEnable(IVT_INT_USART6);

}
#line 98 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_StartRx(void) {
 RXNEIE_USART6_CR1_bit = 1;
}
#line 104 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_StartTx(void) {
 TXEIE_USART6_CR1_bit = 1;
}
#line 115 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_Initialize(void) {
 UART6_RxQueueInit();
 UART6_TxQueueInit();

 UART6_SetBaud();
 UART6_StartRx();
}
#line 126 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_RxQueueInit(void) {
 RxIn = RxOut = 0;
 RcvBufPtr = 0;
}
#line 135 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
char UART6_GetChar(char *rxbyte) {
 if (RxIn != RxOut) {
 *rxbyte = RxQueue[RxOut++];
 if (RxOut > ( 256 -1))
 RxOut = 0;
 return 1;
 }else{
 return 0;
 }
}
#line 148 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_Rx(void) {
 UART6_RxFuncPtr();
}
#line 155 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_Rx1(void){
 char rxchar;

 if (UART6_GetChar(&rxchar)) {
 switch (rxchar) {
 case  0x00 :
 break;

 case '\r':
 break;

 case '\n':
 RcvBuf[RcvBufPtr++] = rxchar;
 RcvBuf[RcvBufPtr] = 0;
 RcvBufPtr = 0;
 UART6_RxFuncPtr = UART6_Rx2;
 break;

 default:
 if (RcvBufPtr < ( 256 -2))
 RcvBuf[RcvBufPtr++] = rxchar;
 break;
 }
 }
}
#line 184 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_Rx2(void) {
 char *BufNum;

 switch (RcvBuf[0]) {




 case 'a':
 strcpy(TestBuffer,"one,two,three,four,five");
 UART6_PutQueue("ACK\r\n");
 break;

 case 'b':
 if (GetToken(TestBuffer,Token) >= 0) {
 BufNum = GetBuffer();
 sprintf(BufNum,"%s\r\n",Token);
 UART6_PutQueue(BufNum);
 } else {
 UART6_PutQueue("No more tokens\r\n");
 }
 break;

 case 'c':
 while ((GetToken(TestBuffer,Token)) >= 0) {
 BufNum = GetBuffer();
 sprintf(BufNum,"%s\r\n",Token);
 UART6_PutQueue(BufNum);
 }
 UART6_PutQueue("No more tokens\r\n");
 break;

 case 'd':
 break;

 case 'e':
 break;

 case 'f':
 UART2_PutQueue("AT+CMGD=?\r\n");
 break;

 case 'g':
 UART2_PutQueue("AT+CMGD=1\r\n");
 break;

 case 'h':
 UART2_PutQueue("AT+CMGD=2\r\n");
 break;

 case 'i':
 UART2_PutQueue("AT+CMGD=3\r\n");
 break;

 case 'j':
 UART2_PutQueue("ATE0\r\n");
 break;

 case 'k':
 UART2_PutQueue("ATE1\r\n");
 break;

 case 'l':
 GSM2_KeyOn();
 UART6_PutQueue("ACK\r\n");
 break;

 case 'm':
 GSM2_KeyOff();
 UART6_PutQueue("ACK\r\n");
 break;

 case 'n':
 break;

 case 'o':
 GSM2_State = 10;
 break;

 case 'p':
 GSM2_State = 20;
 break;

 case 'r':
 GSM2_State = 1;
 UART6_PutQueue("ACK\r\n");
 break;

 case 's':
 GSM2_State = 6;
 break;

 case 't':
 GSM2_State = 30;
 UART6_PutQueue("ACK\r\n");
 break;

 case 'u':
 UART2_PutQueue("AT+CMGL=\"ALL\"\r\n");
 break;

 case 'v':
 UART2_PutQueue("AT\r");
 break;

 case 'w':
 GSM2_State = 40;
 break;

 case 'x':
 UART2_PutQueue("AT+CREG?\r\n");
 break;

 case 'y':
 UART2_PutQueue("AT+CGREG?\r\n");
 break;

 case 'z':
 UART2_PutQueue("AT+COPS?\r\n");
 break;


 default:
 UART6_PutQueue("Unknown command: ");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
 UART6_PutQueue(BufNum);
 break;
 }
 UART6_RxFuncPtr = UART6_Rx1;
}
#line 322 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_TxQueueInit(void) {
 TxIn = TxOut = 0;
 XmtBufPtr = 0;
}
#line 330 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_PutQueue(char *msg) {
 TxQueue[TxIn++] = msg;
 if (TxIn > ( 64 -1))
 TxIn = 0;
}
#line 338 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_SendMsg(char *s) {
 XmtBuf = s;
 XmtBufPtr = 0;
 UART6_StartTx();
}
#line 347 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/UART6.c"
void UART6_CheckQueue(void) {
 if (TXEIE_USART6_CR1_bit == 0) {
 if (TxIn != TxOut) {
 UART6_SendMsg(TxQueue[TxOut++]);
 if (TxOut > ( 64 -1))
 TxOut = 0;
 }
 }
}
