#line 1 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/app.h"
#line 19 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/app.h"
void GSM2_Initialize(void);
void GSM2_KeyOn(void);
void GSM2_KeyOff(void);
char GSM2_RdStat(void);
short WaitForResponse(void);
void CheckTimeout(void);

void GSM2_TaskMgr(void);

short GetToken(char *s, char *t);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/buffers.h"
#line 14 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
#line 20 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart2.h"
#line 21 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart2.h"
void UART2_SetBaud(void);
void UART2_StartRx(void);
void UART2_StartTx(void);

void UART2_Initialize(void);

void UART2_RxQueueInit(void);
char UART2_GetChar(char *rxbyte);

void UART2_Rx(void);
void UART2_Rx1(void);
void UART2_Rx2(void);


void UART2_TxQueueInit(void);
void UART2_PutQueue(char *msg);

void UART2_SendMsg(char *s);
void UART2_CheckQueue(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
#line 9 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void TimerInit();
void TimerCheck();
#line 31 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void init_timerpool(void);
#line 52 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void irqhandler_timer(void);
#line 27 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
sbit GSM2_STAT at GPIOB_IDR.B1;
sbit GSM2_PWRKEY at GPIOB_ODR.B12;
sbit GSM2_RTS at GPIOA_ODR.B15;
sbit GSM2_RI at GPIOD_IDR.B14;
sbit GSM2_CTS at GPIOE_IDR.B2;



char GSM2_State = 0;
char AppState = 0;
char ResponseBuf[256];

unsigned short int TimerHandle;




extern char U2_MsgFlg;
extern char U2_RcvBuf[];
#line 51 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
void GSM2_Initialize(void) {

 GPIO_Clk_Enable(&GPIOA_BASE);
 GPIO_Clk_Enable(&GPIOB_BASE);
 GPIO_Clk_Enable(&GPIOD_BASE);
 GPIO_Clk_Enable(&GPIOE_BASE);

 GPIO_Digital_Input(&GPIOB_BASE,_GPIO_PINMASK_1);
 GPIO_Digital_Output(&GPIOB_BASE,_GPIO_PINMASK_12);
 GPIO_Digital_Output(&GPIOA_BASE,_GPIO_PINMASK_15);
 GPIO_Digital_Input(&GPIOD_BASE,_GPIO_PINMASK_14);
 GPIO_Digital_Input(&GPIOE_BASE,_GPIO_PINMASK_2);

 GSM2_RTS = 1;
}
#line 69 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
void GSM2_KeyOn(void) {
 GSM2_PWRKEY = 1;
}
#line 75 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
void GSM2_KeyOff(void) {
 GSM2_PWRKEY = 0;
}
#line 81 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
char GSM2_RdStat(void) {
 if (GSM2_STAT)
 return 1;
 else
 return 0;
}
#line 90 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
short WaitForResponse(void) {
 char *BufNum;

 if (U2_MsgFlg) {
 BufNum = GetBuffer();
 strcpy(BufNum,U2_RcvBuf);
 U2_MsgFlg = 0;

 UART6_PutQueue(BufNum);

 if ((BufNum[0] == '\r') && (BufNum[1] == '\n')) {

 return  0 ;
 } else if ((BufNum[0] == 'O') && (BufNum[1] == 'K')) {

 return  1 ;
 } else if ((BufNum[0] =='>') && (BufNum[1] == ' ')) {
 return  2 ;
 }
 } else {
 return  -1 ;
 }
}
#line 116 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
void CheckTimeout(void) {
 if (check_timer(TimerHandle) == 0) {
 free_timer(TimerHandle);
 UART6_PutQueue("Timeout\r\n");
 GSM2_State = 0;
 }
}
#line 128 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
void GSM2_TaskMgr(void) {
 char *BufNum;
 short ResponseCode;

 switch (GSM2_State) {


 case 0:
 ResponseCode = WaitForResponse();
 if (ResponseCode >= 0) {
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {

 }
 }
 break;




 case 1:
 GSM2_KeyOn();
 TimerHandle = get_timer();
 GSM2_State = 2;
 break;
 case 2:
 if (GSM2_RdStat()) {
 set_timer(TimerHandle,100);
 GSM2_State = 3;
 }
 break;
 case 3:
 if (check_timer(TimerHandle) == 0) {
 free_timer(TimerHandle);
 GSM2_KeyOff();
 GSM2_State = 0;
 }
 break;




 case 6:
 UART2_PutQueue("AT+IPR=9600\r\n");
 GSM2_State = 7;
 break;
 case 7:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {
 }
 if (ResponseCode ==  1 ) {
 GSM2_State = 8;
 }
 break;
 case 8:
 UART2_PutQueue("AT&W\r\n");
 GSM2_State = 9;
 break;
 case 9:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {
 }
 if (ResponseCode ==  1 ) {
 GSM2_State = 0;
 }
 break;




 case 10:
 TimerHandle = get_timer();
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CSQ\r\n");
 GSM2_State = 11;
 break;
 case 11:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CREG?\r\n");
 GSM2_State = 12;
 } else
 CheckTimeout();
 break;
 case 12:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CGREG?\r\n");
 GSM2_State = 13;
 } else
 CheckTimeout();
 break;
 case 13:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+COPS?\r\n");
 GSM2_State = 14;
 } else
 CheckTimeout();
 break;
 case 14:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 free_timer(TimerHandle);
 GSM2_State = 0;
 } else
 CheckTimeout();
 break;




 case 20:
 UART2_PutQueue("AT+QPOWD=1\r\n");
 GSM2_State = 21;
 break;
 case 21:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else {
 GSM2_State = 0;
 }
 break;




 case 30:
 TimerHandle = get_timer();
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CMGF=1\r\n");
 GSM2_State = 31;
 break;
 case 31:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CSCS=\"GSM\"\r\n");
 GSM2_State = 33;
 } else
 CheckTimeout();
 break;

 case 32:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("ATE0\r\n");
 GSM2_State = 33;
 } else
 CheckTimeout();
 break;

 case 33:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CMGS=\"+19052524261\"\r\n");
 GSM2_State = 34;
 } else
 CheckTimeout();
 break;
 case 34:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  2 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("Hello world\r\n");
 GSM2_State = 35;
 } else
 CheckTimeout();
 break;
 case 35:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  2 ) {
 set_timer(TimerHandle,5000);
 BufNum = GetBuffer();
 BufNum[0] = 0x1A;
 BufNum[1] = 0x0D;
 BufNum[2] = 0x00;

 UART2_PutQueue(BufNum);
 GSM2_State = 37;
 } else
 CheckTimeout();
 break;

 case 36:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("ATE1\r\n");
 GSM2_State = 37;
 } else
 CheckTimeout();
 break;

 case 37:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 free_timer(TimerHandle);
 GSM2_State = 0;
 } else
 CheckTimeout();
 break;




 case 40:
 TimerHandle = get_timer();
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CMGF=1\r\n");
 GSM2_State = 41;
 break;
 case 41:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CSCS=\"GSM\"\r\n");
 GSM2_State = 42;
 } else
 CheckTimeout();
 break;
 case 42:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CMGD=1\r\n");
 GSM2_State = 43;
 } else
 CheckTimeout();
 break;
 case 43:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CMGD=2\r\n");
 GSM2_State = 44;
 } else
 CheckTimeout();
 break;
 case 44:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 set_timer(TimerHandle,5000);
 UART2_PutQueue("AT+CMGD=3\r\n");
 GSM2_State = 45;
 } else
 CheckTimeout();
 break;
 case 45:
 ResponseCode = WaitForResponse();
 if (ResponseCode ==  0 ) {

 } else if (ResponseCode ==  1 ) {
 free_timer(TimerHandle);
 GSM2_State = 0;
 } else
 CheckTimeout();
 break;
 }
}
#line 433 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/App.c"
short GetToken(char *s, char *t) {
 char *p;

 if (strlen(s) == 0) {
 return (-1);
 }
 p = strchr(s,',');
 if (p ==  0x00 ) {
 strcpy(t,s);
 strcpy(s,"");
 return 0;
 }
 s[strlen(s)-strlen(p)] = '\0';
 strcpy(t,s);
 p++;
 strcpy(s,p);
 return 1;
}
