/**************************************************************************************************
  App.h
  Application.
**************************************************************************************************/
#ifndef APP_H
#define APP_H


// Defines
#define NEG -1
#define EMPTY 0
#define OK 1
#define PROMPT 2




// Function Prototypes
void GSM2_Initialize(void);
void GSM2_KeyOn(void);
void GSM2_KeyOff(void);
char GSM2_RdStat(void);
short WaitForResponse(void);
void CheckTimeout(void);

void GSM2_TaskMgr(void);

short GetToken(char *s, char *t);



#endif