_Write_to_Data_Lines:
;GSM2_driver.c,29 :: 		void Write_to_Data_Lines(unsigned char _hi, unsigned char _lo) {
; _lo start address is: 4 (R1)
; _lo end address is: 4 (R1)
; _lo start address is: 4 (R1)
;GSM2_driver.c,31 :: 		temp = GPIOE_ODR;
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
; temp start address is: 8 (R2)
LDR	R2, [R2, #0]
;GSM2_driver.c,32 :: 		temp &= 0x00FF;
AND	R3, R2, #255
UXTH	R3, R3
; temp end address is: 8 (R2)
;GSM2_driver.c,33 :: 		GPIOE_ODR = temp | (_hi << 8);
LSLS	R2, R0, #8
UXTH	R2, R2
ORRS	R3, R2
UXTH	R3, R3
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
STR	R3, [R2, #0]
;GSM2_driver.c,34 :: 		temp = GPIOG_ODR;
MOVW	R2, #lo_addr(GPIOG_ODR+0)
MOVT	R2, #hi_addr(GPIOG_ODR+0)
LDR	R0, [R2, #0]
;GSM2_driver.c,35 :: 		temp &= 0xFF00;
AND	R2, R0, #65280
UXTH	R2, R2
;GSM2_driver.c,36 :: 		GPIOG_ODR = temp | _lo;
ORR	R3, R2, R1, LSL #0
UXTH	R3, R3
; _lo end address is: 4 (R1)
MOVW	R2, #lo_addr(GPIOG_ODR+0)
MOVT	R2, #hi_addr(GPIOG_ODR+0)
STR	R3, [R2, #0]
;GSM2_driver.c,37 :: 		}
L_end_Write_to_Data_Lines:
BX	LR
; end of _Write_to_Data_Lines
_TFT_mikromedia_Set_Index:
;GSM2_driver.c,39 :: 		void TFT_mikromedia_Set_Index(unsigned short index) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;GSM2_driver.c,40 :: 		TFT_RS = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
STR	R2, [R1, #0]
;GSM2_driver.c,41 :: 		Write_to_Data_Lines(0, index);
UXTB	R1, R0
MOVS	R0, #0
BL	_Write_to_Data_Lines+0
;GSM2_driver.c,42 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
STR	R2, [R1, #0]
;GSM2_driver.c,43 :: 		asm nop;
NOP
;GSM2_driver.c,44 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
STR	R2, [R1, #0]
;GSM2_driver.c,45 :: 		}
L_end_TFT_mikromedia_Set_Index:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _TFT_mikromedia_Set_Index
_TFT_mikromedia_Write_Command:
;GSM2_driver.c,47 :: 		void TFT_mikromedia_Write_Command(unsigned short cmd) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;GSM2_driver.c,48 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
STR	R2, [R1, #0]
;GSM2_driver.c,49 :: 		Write_to_Data_Lines(0, cmd);
UXTB	R1, R0
MOVS	R0, #0
BL	_Write_to_Data_Lines+0
;GSM2_driver.c,50 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
STR	R2, [R1, #0]
;GSM2_driver.c,51 :: 		asm nop;
NOP
;GSM2_driver.c,52 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
STR	R2, [R1, #0]
;GSM2_driver.c,53 :: 		}
L_end_TFT_mikromedia_Write_Command:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _TFT_mikromedia_Write_Command
_TFT_Write_to_16bitPort:
;GSM2_driver.c,55 :: 		void TFT_Write_to_16bitPort(unsigned int _data) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
STRH	R0, [SP, #4]
;GSM2_driver.c,56 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
STR	R2, [R1, #0]
;GSM2_driver.c,57 :: 		Write_to_Data_Lines(Hi(_data), Lo(_data));
ADD	R3, SP, #4
LDRB	R1, [R3, #0]
UXTB	R2, R1
ADDS	R1, R3, #1
LDRB	R1, [R1, #0]
UXTB	R0, R1
UXTB	R1, R2
BL	_Write_to_Data_Lines+0
;GSM2_driver.c,58 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
STR	R2, [R1, #0]
;GSM2_driver.c,59 :: 		asm nop;
NOP
;GSM2_driver.c,60 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
STR	R2, [R1, #0]
;GSM2_driver.c,61 :: 		}
L_end_TFT_Write_to_16bitPort:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _TFT_Write_to_16bitPort
GSM2_driver_InitializeTouchPanel:
;GSM2_driver.c,62 :: 		static void InitializeTouchPanel() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;GSM2_driver.c,63 :: 		TFT_Set_Active(&TFT_mikromedia_Set_Index, &TFT_mikromedia_Write_Command, &TFT_Write_to_16bitPort);
MOVW	R2, #lo_addr(_TFT_Write_to_16bitPort+0)
MOVT	R2, #hi_addr(_TFT_Write_to_16bitPort+0)
MOVW	R1, #lo_addr(_TFT_mikromedia_Write_Command+0)
MOVT	R1, #hi_addr(_TFT_mikromedia_Write_Command+0)
MOVW	R0, #lo_addr(_TFT_mikromedia_Set_Index+0)
MOVT	R0, #hi_addr(_TFT_mikromedia_Set_Index+0)
BL	_TFT_Set_Active+0
;GSM2_driver.c,64 :: 		TFT_Init_SSD1963(480, 272);
MOVW	R1, #272
MOVW	R0, #480
BL	_TFT_Init_SSD1963+0
;GSM2_driver.c,66 :: 		TFT_Set_DBC_SSD1963(255);
MOVS	R0, #255
BL	_TFT_Set_DBC_SSD1963+0
;GSM2_driver.c,68 :: 		PenDown = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
STRB	R1, [R0, #0]
;GSM2_driver.c,69 :: 		PressedObject = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_PressedObject+0)
MOVT	R0, #hi_addr(_PressedObject+0)
STR	R1, [R0, #0]
;GSM2_driver.c,70 :: 		PressedObjectType = -1;
MOVW	R1, #65535
SXTH	R1, R1
MOVW	R0, #lo_addr(_PressedObjectType+0)
MOVT	R0, #hi_addr(_PressedObjectType+0)
STRH	R1, [R0, #0]
;GSM2_driver.c,71 :: 		}
L_end_InitializeTouchPanel:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of GSM2_driver_InitializeTouchPanel
GSM2_driver_InitializeObjects:
;GSM2_driver.c,88 :: 		static void InitializeObjects() {
;GSM2_driver.c,89 :: 		Screen1.Color                     = 0x5AEB;
MOVW	R1, #23275
MOVW	R0, #lo_addr(_Screen1+0)
MOVT	R0, #hi_addr(_Screen1+0)
STRH	R1, [R0, #0]
;GSM2_driver.c,90 :: 		Screen1.Width                     = 480;
MOVW	R1, #480
MOVW	R0, #lo_addr(_Screen1+2)
MOVT	R0, #hi_addr(_Screen1+2)
STRH	R1, [R0, #0]
;GSM2_driver.c,91 :: 		Screen1.Height                    = 272;
MOVW	R1, #272
MOVW	R0, #lo_addr(_Screen1+4)
MOVT	R0, #hi_addr(_Screen1+4)
STRH	R1, [R0, #0]
;GSM2_driver.c,92 :: 		Screen1.ButtonsCount              = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Screen1+8)
MOVT	R0, #hi_addr(_Screen1+8)
STRH	R1, [R0, #0]
;GSM2_driver.c,93 :: 		Screen1.Buttons                   = Screen1_Buttons;
MOVW	R1, #lo_addr(_Screen1_Buttons+0)
MOVT	R1, #hi_addr(_Screen1_Buttons+0)
MOVW	R0, #lo_addr(_Screen1+12)
MOVT	R0, #hi_addr(_Screen1+12)
STR	R1, [R0, #0]
;GSM2_driver.c,94 :: 		Screen1.ObjectsCount              = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Screen1+6)
MOVT	R0, #hi_addr(_Screen1+6)
STRH	R1, [R0, #0]
;GSM2_driver.c,97 :: 		Button1.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Button1+0)
MOVT	R0, #hi_addr(_Button1+0)
STR	R1, [R0, #0]
;GSM2_driver.c,98 :: 		Button1.Order           = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+4)
MOVT	R0, #hi_addr(_Button1+4)
STRB	R1, [R0, #0]
;GSM2_driver.c,99 :: 		Button1.Left            = 62;
MOVS	R1, #62
MOVW	R0, #lo_addr(_Button1+6)
MOVT	R0, #hi_addr(_Button1+6)
STRH	R1, [R0, #0]
;GSM2_driver.c,100 :: 		Button1.Top             = 74;
MOVS	R1, #74
MOVW	R0, #lo_addr(_Button1+8)
MOVT	R0, #hi_addr(_Button1+8)
STRH	R1, [R0, #0]
;GSM2_driver.c,101 :: 		Button1.Width           = 126;
MOVS	R1, #126
MOVW	R0, #lo_addr(_Button1+10)
MOVT	R0, #hi_addr(_Button1+10)
STRH	R1, [R0, #0]
;GSM2_driver.c,102 :: 		Button1.Height          = 62;
MOVS	R1, #62
MOVW	R0, #lo_addr(_Button1+12)
MOVT	R0, #hi_addr(_Button1+12)
STRH	R1, [R0, #0]
;GSM2_driver.c,103 :: 		Button1.Pen_Width       = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+14)
MOVT	R0, #hi_addr(_Button1+14)
STRB	R1, [R0, #0]
;GSM2_driver.c,104 :: 		Button1.Pen_Color       = 0x0000;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+16)
MOVT	R0, #hi_addr(_Button1+16)
STRH	R1, [R0, #0]
;GSM2_driver.c,105 :: 		Button1.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+18)
MOVT	R0, #hi_addr(_Button1+18)
STRB	R1, [R0, #0]
;GSM2_driver.c,106 :: 		Button1.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+19)
MOVT	R0, #hi_addr(_Button1+19)
STRB	R1, [R0, #0]
;GSM2_driver.c,107 :: 		Button1.Transparent     = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+20)
MOVT	R0, #hi_addr(_Button1+20)
STRB	R1, [R0, #0]
;GSM2_driver.c,108 :: 		Button1.Caption         = Button1_Caption;
MOVW	R1, #lo_addr(_Button1_Caption+0)
MOVT	R1, #hi_addr(_Button1_Caption+0)
MOVW	R0, #lo_addr(_Button1+24)
MOVT	R0, #hi_addr(_Button1+24)
STR	R1, [R0, #0]
;GSM2_driver.c,109 :: 		Button1.TextAlign       = _taCenter;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+28)
MOVT	R0, #hi_addr(_Button1+28)
STRB	R1, [R0, #0]
;GSM2_driver.c,110 :: 		Button1.FontName        = Tahoma11x13_Regular;
MOVW	R1, #lo_addr(_Tahoma11x13_Regular+0)
MOVT	R1, #hi_addr(_Tahoma11x13_Regular+0)
MOVW	R0, #lo_addr(_Button1+32)
MOVT	R0, #hi_addr(_Button1+32)
STR	R1, [R0, #0]
;GSM2_driver.c,111 :: 		Button1.PressColEnabled = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+46)
MOVT	R0, #hi_addr(_Button1+46)
STRB	R1, [R0, #0]
;GSM2_driver.c,112 :: 		Button1.Font_Color      = 0x0000;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+36)
MOVT	R0, #hi_addr(_Button1+36)
STRH	R1, [R0, #0]
;GSM2_driver.c,113 :: 		Button1.Gradient        = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+38)
MOVT	R0, #hi_addr(_Button1+38)
STRB	R1, [R0, #0]
;GSM2_driver.c,114 :: 		Button1.Gradient_Orientation = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+39)
MOVT	R0, #hi_addr(_Button1+39)
STRB	R1, [R0, #0]
;GSM2_driver.c,115 :: 		Button1.Gradient_Start_Color = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Button1+40)
MOVT	R0, #hi_addr(_Button1+40)
STRH	R1, [R0, #0]
;GSM2_driver.c,116 :: 		Button1.Gradient_End_Color = 0xC618;
MOVW	R1, #50712
MOVW	R0, #lo_addr(_Button1+42)
MOVT	R0, #hi_addr(_Button1+42)
STRH	R1, [R0, #0]
;GSM2_driver.c,117 :: 		Button1.Color           = 0xC618;
MOVW	R1, #50712
MOVW	R0, #lo_addr(_Button1+44)
MOVT	R0, #hi_addr(_Button1+44)
STRH	R1, [R0, #0]
;GSM2_driver.c,118 :: 		Button1.Press_Color     = 0xE71C;
MOVW	R1, #59164
MOVW	R0, #lo_addr(_Button1+48)
MOVT	R0, #hi_addr(_Button1+48)
STRH	R1, [R0, #0]
;GSM2_driver.c,119 :: 		Button1.OnUpPtr         = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+52)
MOVT	R0, #hi_addr(_Button1+52)
STR	R1, [R0, #0]
;GSM2_driver.c,120 :: 		Button1.OnDownPtr       = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+56)
MOVT	R0, #hi_addr(_Button1+56)
STR	R1, [R0, #0]
;GSM2_driver.c,121 :: 		Button1.OnClickPtr      = Button1OnClick;
MOVW	R1, #lo_addr(_Button1OnClick+0)
MOVT	R1, #hi_addr(_Button1OnClick+0)
MOVW	R0, #lo_addr(_Button1+60)
MOVT	R0, #hi_addr(_Button1+60)
STR	R1, [R0, #0]
;GSM2_driver.c,122 :: 		Button1.OnPressPtr      = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+64)
MOVT	R0, #hi_addr(_Button1+64)
STR	R1, [R0, #0]
;GSM2_driver.c,123 :: 		}
L_end_InitializeObjects:
BX	LR
; end of GSM2_driver_InitializeObjects
GSM2_driver_IsInsideObject:
;GSM2_driver.c,125 :: 		static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
; Top start address is: 12 (R3)
; Left start address is: 8 (R2)
; Y start address is: 4 (R1)
; Top end address is: 12 (R3)
; Left end address is: 8 (R2)
; Y end address is: 4 (R1)
; Y start address is: 4 (R1)
; Left start address is: 8 (R2)
; Top start address is: 12 (R3)
; Width start address is: 20 (R5)
LDRH	R5, [SP, #0]
; Height start address is: 24 (R6)
LDRH	R6, [SP, #4]
;GSM2_driver.c,126 :: 		if ( (Left<= X) && (Left+ Width - 1 >= X) &&
CMP	R2, R0
IT	HI
BHI	L_GSM2_driver_IsInsideObject68
ADDS	R4, R2, R5
UXTH	R4, R4
; Left end address is: 8 (R2)
; Width end address is: 20 (R5)
SUBS	R4, R4, #1
UXTH	R4, R4
CMP	R4, R0
IT	CC
BCC	L_GSM2_driver_IsInsideObject67
;GSM2_driver.c,127 :: 		(Top <= Y)  && (Top + Height - 1 >= Y) )
CMP	R3, R1
IT	HI
BHI	L_GSM2_driver_IsInsideObject66
ADDS	R4, R3, R6
UXTH	R4, R4
; Top end address is: 12 (R3)
; Height end address is: 24 (R6)
SUBS	R4, R4, #1
UXTH	R4, R4
CMP	R4, R1
IT	CC
BCC	L_GSM2_driver_IsInsideObject65
; Y end address is: 4 (R1)
L_GSM2_driver_IsInsideObject64:
;GSM2_driver.c,128 :: 		return 1;
MOVS	R0, #1
IT	AL
BAL	L_end_IsInsideObject
;GSM2_driver.c,126 :: 		if ( (Left<= X) && (Left+ Width - 1 >= X) &&
L_GSM2_driver_IsInsideObject68:
L_GSM2_driver_IsInsideObject67:
;GSM2_driver.c,127 :: 		(Top <= Y)  && (Top + Height - 1 >= Y) )
L_GSM2_driver_IsInsideObject66:
L_GSM2_driver_IsInsideObject65:
;GSM2_driver.c,130 :: 		return 0;
MOVS	R0, #0
;GSM2_driver.c,131 :: 		}
L_end_IsInsideObject:
BX	LR
; end of GSM2_driver_IsInsideObject
_DrawButton:
;GSM2_driver.c,137 :: 		void DrawButton(TButton *Abutton) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;GSM2_driver.c,138 :: 		if (Abutton->Visible == 1) {
ADDW	R1, R0, #18
LDRB	R1, [R1, #0]
CMP	R1, #1
IT	NE
BNE	L_DrawButton4
;GSM2_driver.c,139 :: 		if (object_pressed == 1) {
MOVW	R1, #lo_addr(_object_pressed+0)
MOVT	R1, #hi_addr(_object_pressed+0)
LDRB	R1, [R1, #0]
CMP	R1, #1
IT	NE
BNE	L_DrawButton5
;GSM2_driver.c,140 :: 		object_pressed = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_object_pressed+0)
MOVT	R1, #hi_addr(_object_pressed+0)
STRB	R2, [R1, #0]
;GSM2_driver.c,141 :: 		TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
ADDW	R1, R0, #40
LDRH	R1, [R1, #0]
UXTH	R6, R1
ADDW	R1, R0, #42
LDRH	R1, [R1, #0]
UXTH	R5, R1
ADDW	R1, R0, #39
LDRB	R1, [R1, #0]
UXTB	R4, R1
ADDW	R1, R0, #38
LDRB	R1, [R1, #0]
UXTB	R3, R1
ADDW	R1, R0, #48
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #20
LDRB	R1, [R1, #0]
STR	R0, [SP, #4]
UXTB	R0, R1
UXTH	R1, R2
UXTB	R2, R3
UXTB	R3, R4
PUSH	(R6)
PUSH	(R5)
BL	_TFT_Set_Brush+0
ADD	SP, SP, #8
LDR	R0, [SP, #4]
;GSM2_driver.c,142 :: 		}
IT	AL
BAL	L_DrawButton6
L_DrawButton5:
;GSM2_driver.c,144 :: 		TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
ADDW	R1, R0, #42
LDRH	R1, [R1, #0]
UXTH	R6, R1
ADDW	R1, R0, #40
LDRH	R1, [R1, #0]
UXTH	R5, R1
ADDW	R1, R0, #39
LDRB	R1, [R1, #0]
UXTB	R4, R1
ADDW	R1, R0, #38
LDRB	R1, [R1, #0]
UXTB	R3, R1
ADDW	R1, R0, #44
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #20
LDRB	R1, [R1, #0]
STR	R0, [SP, #4]
UXTB	R0, R1
UXTH	R1, R2
UXTB	R2, R3
UXTB	R3, R4
PUSH	(R6)
PUSH	(R5)
BL	_TFT_Set_Brush+0
ADD	SP, SP, #8
LDR	R0, [SP, #4]
;GSM2_driver.c,145 :: 		}
L_DrawButton6:
;GSM2_driver.c,146 :: 		TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
ADDW	R1, R0, #14
LDRB	R1, [R1, #0]
UXTB	R2, R1
ADDW	R1, R0, #16
LDRH	R1, [R1, #0]
STR	R0, [SP, #4]
UXTH	R0, R1
UXTB	R1, R2
BL	_TFT_Set_Pen+0
LDR	R0, [SP, #4]
;GSM2_driver.c,147 :: 		TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
ADDW	R1, R0, #8
LDRH	R2, [R1, #0]
ADDW	R1, R0, #12
LDRH	R1, [R1, #0]
ADDS	R1, R2, R1
UXTH	R1, R1
SUBS	R5, R1, #1
ADDS	R1, R0, #6
LDRH	R4, [R1, #0]
ADDW	R1, R0, #10
LDRH	R1, [R1, #0]
ADDS	R1, R4, R1
UXTH	R1, R1
SUBS	R3, R1, #1
SXTH	R2, R2
SXTH	R1, R4
STR	R0, [SP, #4]
SXTH	R0, R1
SXTH	R1, R2
SXTH	R2, R3
SXTH	R3, R5
BL	_TFT_Rectangle+0
LDR	R0, [SP, #4]
;GSM2_driver.c,148 :: 		TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
ADDW	R1, R0, #36
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #32
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R1
UXTH	R1, R2
MOVS	R2, #0
BL	_TFT_Set_Font+0
LDR	R0, [SP, #4]
;GSM2_driver.c,149 :: 		TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
ADDW	R1, R0, #8
LDRH	R1, [R1, #0]
UXTH	R3, R1
ADDS	R1, R0, #6
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R1
UXTH	R1, R2
UXTH	R2, R3
BL	_TFT_Write_Text_Return_Pos+0
LDR	R0, [SP, #4]
;GSM2_driver.c,150 :: 		if (Abutton->TextAlign == _taLeft)
ADDW	R1, R0, #28
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L_DrawButton7
;GSM2_driver.c,151 :: 		TFT_Write_Text(Abutton->Caption, Abutton->Left + 4, (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
ADDW	R1, R0, #8
LDRH	R3, [R1, #0]
ADDW	R1, R0, #12
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_caption_height+0)
MOVT	R1, #hi_addr(_caption_height+0)
LDRH	R1, [R1, #0]
SUB	R1, R2, R1
UXTH	R1, R1
LSRS	R1, R1, #1
UXTH	R1, R1
ADDS	R3, R3, R1
ADDS	R1, R0, #6
LDRH	R1, [R1, #0]
ADDS	R2, R1, #4
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
MOV	R0, R1
UXTH	R1, R2
UXTH	R2, R3
BL	_TFT_Write_Text+0
IT	AL
BAL	L_DrawButton8
L_DrawButton7:
;GSM2_driver.c,152 :: 		else if (Abutton->TextAlign == _taCenter)
ADDW	R1, R0, #28
LDRB	R1, [R1, #0]
CMP	R1, #1
IT	NE
BNE	L_DrawButton9
;GSM2_driver.c,153 :: 		TFT_Write_Text(Abutton->Caption, (Abutton->Left + (Abutton->Width - caption_length) / 2), (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
ADDW	R1, R0, #8
LDRH	R3, [R1, #0]
ADDW	R1, R0, #12
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_caption_height+0)
MOVT	R1, #hi_addr(_caption_height+0)
LDRH	R1, [R1, #0]
SUB	R1, R2, R1
UXTH	R1, R1
LSRS	R1, R1, #1
UXTH	R1, R1
ADDS	R4, R3, R1
ADDS	R1, R0, #6
LDRH	R3, [R1, #0]
ADDW	R1, R0, #10
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_caption_length+0)
MOVT	R1, #hi_addr(_caption_length+0)
LDRH	R1, [R1, #0]
SUB	R1, R2, R1
UXTH	R1, R1
LSRS	R1, R1, #1
UXTH	R1, R1
ADDS	R2, R3, R1
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
MOV	R0, R1
UXTH	R1, R2
UXTH	R2, R4
BL	_TFT_Write_Text+0
IT	AL
BAL	L_DrawButton10
L_DrawButton9:
;GSM2_driver.c,154 :: 		else if (Abutton->TextAlign == _taRight)
ADDW	R1, R0, #28
LDRB	R1, [R1, #0]
CMP	R1, #2
IT	NE
BNE	L_DrawButton11
;GSM2_driver.c,155 :: 		TFT_Write_Text(Abutton->Caption, Abutton->Left + (Abutton->Width - caption_length - 4), (Abutton->Top + (Abutton->Height - caption_height) / 2));
ADDW	R1, R0, #8
LDRH	R3, [R1, #0]
ADDW	R1, R0, #12
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_caption_height+0)
MOVT	R1, #hi_addr(_caption_height+0)
LDRH	R1, [R1, #0]
SUB	R1, R2, R1
UXTH	R1, R1
LSRS	R1, R1, #1
UXTH	R1, R1
ADDS	R4, R3, R1
ADDS	R1, R0, #6
LDRH	R3, [R1, #0]
ADDW	R1, R0, #10
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_caption_length+0)
MOVT	R1, #hi_addr(_caption_length+0)
LDRH	R1, [R1, #0]
SUB	R1, R2, R1
UXTH	R1, R1
SUBS	R1, R1, #4
UXTH	R1, R1
ADDS	R2, R3, R1
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
MOV	R0, R1
UXTH	R1, R2
UXTH	R2, R4
BL	_TFT_Write_Text+0
L_DrawButton11:
L_DrawButton10:
L_DrawButton8:
;GSM2_driver.c,156 :: 		}
L_DrawButton4:
;GSM2_driver.c,157 :: 		}
L_end_DrawButton:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _DrawButton
_DrawScreen:
;GSM2_driver.c,159 :: 		void DrawScreen(TScreen *aScreen) {
SUB	SP, SP, #32
STR	LR, [SP, #0]
;GSM2_driver.c,165 :: 		object_pressed = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_object_pressed+0)
MOVT	R1, #hi_addr(_object_pressed+0)
STRB	R2, [R1, #0]
;GSM2_driver.c,166 :: 		order = 0;
MOVS	R1, #0
STRH	R1, [SP, #4]
;GSM2_driver.c,167 :: 		button_idx = 0;
MOVS	R1, #0
STRB	R1, [SP, #6]
;GSM2_driver.c,168 :: 		CurrentScreen = aScreen;
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
STR	R0, [R1, #0]
;GSM2_driver.c,170 :: 		if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
ADDS	R1, R0, #2
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_display_width+0)
MOVT	R1, #hi_addr(_display_width+0)
LDRH	R1, [R1, #0]
CMP	R1, R2
IT	NE
BNE	L__DrawScreen71
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, R1, #4
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_display_height+0)
MOVT	R1, #hi_addr(_display_height+0)
LDRH	R1, [R1, #0]
CMP	R1, R2
IT	NE
BNE	L__DrawScreen70
IT	AL
BAL	L_DrawScreen14
L__DrawScreen71:
L__DrawScreen70:
;GSM2_driver.c,171 :: 		save_bled = TFT_BLED;
MOVW	R2, #lo_addr(GPIOF_ODR+0)
MOVT	R2, #hi_addr(GPIOF_ODR+0)
STR	R2, [SP, #28]
LDR	R1, [R2, #0]
STRB	R1, [SP, #12]
;GSM2_driver.c,172 :: 		TFT_BLED           = 0;
MOVS	R1, #0
SXTB	R1, R1
STR	R1, [R2, #0]
;GSM2_driver.c,173 :: 		TFT_Set_Active(&TFT_mikromedia_Set_Index, &TFT_mikromedia_Write_Command, &TFT_Write_to_16bitPort);
MOVW	R2, #lo_addr(_TFT_Write_to_16bitPort+0)
MOVT	R2, #hi_addr(_TFT_Write_to_16bitPort+0)
MOVW	R1, #lo_addr(_TFT_mikromedia_Write_Command+0)
MOVT	R1, #hi_addr(_TFT_mikromedia_Write_Command+0)
MOVW	R0, #lo_addr(_TFT_mikromedia_Set_Index+0)
MOVT	R0, #hi_addr(_TFT_mikromedia_Set_Index+0)
BL	_TFT_Set_Active+0
;GSM2_driver.c,174 :: 		TFT_Init_SSD1963(CurrentScreen->Width, CurrentScreen->Height);
MOVW	R3, #lo_addr(_CurrentScreen+0)
MOVT	R3, #hi_addr(_CurrentScreen+0)
STR	R3, [SP, #24]
LDR	R1, [R3, #0]
ADDS	R1, R1, #4
LDRH	R1, [R1, #0]
UXTH	R2, R1
MOV	R1, R3
LDR	R1, [R1, #0]
ADDS	R1, R1, #2
LDRH	R1, [R1, #0]
UXTH	R0, R1
UXTH	R1, R2
BL	_TFT_Init_SSD1963+0
;GSM2_driver.c,175 :: 		TFT_Set_DBC_SSD1963(255);
MOVS	R0, #255
BL	_TFT_Set_DBC_SSD1963+0
;GSM2_driver.c,176 :: 		STMPE610_SetSize(CurrentScreen->Width, CurrentScreen->Height);
MOVW	R3, #lo_addr(_CurrentScreen+0)
MOVT	R3, #hi_addr(_CurrentScreen+0)
LDR	R1, [R3, #0]
ADDS	R1, R1, #4
LDRH	R1, [R1, #0]
UXTH	R2, R1
MOV	R1, R3
LDR	R1, [R1, #0]
ADDS	R1, R1, #2
LDRH	R1, [R1, #0]
UXTH	R0, R1
UXTH	R1, R2
BL	_STMPE610_SetSize+0
;GSM2_driver.c,177 :: 		TFT_Fill_Screen(CurrentScreen->Color);
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
LDRH	R1, [R1, #0]
UXTH	R0, R1
BL	_TFT_Fill_Screen+0
;GSM2_driver.c,178 :: 		display_width = CurrentScreen->Width;
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, R1, #2
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_display_width+0)
MOVT	R1, #hi_addr(_display_width+0)
STRH	R2, [R1, #0]
;GSM2_driver.c,179 :: 		display_height = CurrentScreen->Height;
LDR	R1, [SP, #24]
LDR	R1, [R1, #0]
ADDS	R1, R1, #4
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_display_height+0)
MOVT	R1, #hi_addr(_display_height+0)
STRH	R2, [R1, #0]
;GSM2_driver.c,180 :: 		TFT_BLED           = save_bled;
LDRB	R2, [SP, #12]
LDR	R1, [SP, #28]
STR	R2, [R1, #0]
;GSM2_driver.c,181 :: 		}
IT	AL
BAL	L_DrawScreen15
L_DrawScreen14:
;GSM2_driver.c,183 :: 		TFT_Fill_Screen(CurrentScreen->Color);
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
LDRH	R1, [R1, #0]
UXTH	R0, R1
BL	_TFT_Fill_Screen+0
L_DrawScreen15:
;GSM2_driver.c,186 :: 		while (order < CurrentScreen->ObjectsCount) {
L_DrawScreen16:
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, R1, #6
LDRH	R2, [R1, #0]
LDRH	R1, [SP, #4]
CMP	R1, R2
IT	CS
BCS	L_DrawScreen17
;GSM2_driver.c,187 :: 		if (button_idx < CurrentScreen->ButtonsCount) {
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, #8
LDRH	R2, [R1, #0]
LDRB	R1, [SP, #6]
CMP	R1, R2
IT	CS
BCS	L_DrawScreen18
;GSM2_driver.c,188 :: 		local_button = GetButton(button_idx);
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, #12
LDR	R2, [R1, #0]
LDRB	R1, [SP, #6]
LSLS	R1, R1, #2
ADDS	R1, R2, R1
LDR	R1, [R1, #0]
STR	R1, [SP, #8]
;GSM2_driver.c,189 :: 		if (order == local_button->Order) {
ADDS	R1, R1, #4
LDRB	R2, [R1, #0]
LDRH	R1, [SP, #4]
CMP	R1, R2
IT	NE
BNE	L_DrawScreen19
;GSM2_driver.c,190 :: 		button_idx++;
LDRB	R1, [SP, #6]
ADDS	R1, R1, #1
STRB	R1, [SP, #6]
;GSM2_driver.c,191 :: 		order++;
LDRH	R1, [SP, #4]
ADDS	R1, R1, #1
STRH	R1, [SP, #4]
;GSM2_driver.c,192 :: 		DrawButton(local_button);
LDR	R0, [SP, #8]
BL	_DrawButton+0
;GSM2_driver.c,193 :: 		}
L_DrawScreen19:
;GSM2_driver.c,194 :: 		}
L_DrawScreen18:
;GSM2_driver.c,196 :: 		}
IT	AL
BAL	L_DrawScreen16
L_DrawScreen17:
;GSM2_driver.c,197 :: 		}
L_end_DrawScreen:
LDR	LR, [SP, #0]
ADD	SP, SP, #32
BX	LR
; end of _DrawScreen
_Get_Object:
;GSM2_driver.c,199 :: 		void Get_Object(unsigned int X, unsigned int Y) {
; Y start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Y end address is: 4 (R1)
; Y start address is: 4 (R1)
;GSM2_driver.c,200 :: 		button_order        = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
STRH	R3, [R2, #0]
;GSM2_driver.c,202 :: 		for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
MOVS	R3, #0
SXTH	R3, R3
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
; Y end address is: 4 (R1)
UXTH	R8, R0
UXTH	R7, R1
L_Get_Object20:
; X start address is: 32 (R8)
; Y start address is: 28 (R7)
; Y start address is: 28 (R7)
; Y end address is: 28 (R7)
; X start address is: 32 (R8)
; X end address is: 32 (R8)
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
ADDS	R2, #8
LDRH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	CS
BCS	L_Get_Object21
; Y end address is: 28 (R7)
; X end address is: 32 (R8)
;GSM2_driver.c,203 :: 		local_button = GetButton(_object_count);
; X start address is: 32 (R8)
; Y start address is: 28 (R7)
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
ADDS	R2, #12
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
LSLS	R2, R2, #2
ADDS	R2, R3, R2
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_local_button+0)
MOVT	R2, #hi_addr(_local_button+0)
STR	R3, [R2, #0]
;GSM2_driver.c,204 :: 		if (local_button->Active == 1) {
ADDW	R2, R3, #19
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_Get_Object23
;GSM2_driver.c,206 :: 		local_button->Width, local_button->Height) == 1) {
MOVW	R6, #lo_addr(_local_button+0)
MOVT	R6, #hi_addr(_local_button+0)
LDR	R2, [R6, #0]
ADDS	R2, #12
LDRH	R2, [R2, #0]
UXTH	R5, R2
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, #10
LDRH	R2, [R2, #0]
UXTH	R4, R2
;GSM2_driver.c,205 :: 		if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, #8
LDRH	R2, [R2, #0]
UXTH	R3, R2
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, R2, #6
LDRH	R2, [R2, #0]
UXTH	R1, R7
UXTH	R0, R8
;GSM2_driver.c,206 :: 		local_button->Width, local_button->Height) == 1) {
PUSH	(R5)
PUSH	(R4)
BL	GSM2_driver_IsInsideObject+0
ADD	SP, SP, #8
CMP	R0, #1
IT	NE
BNE	L_Get_Object24
;GSM2_driver.c,207 :: 		button_order = local_button->Order;
MOVW	R4, #lo_addr(_local_button+0)
MOVT	R4, #hi_addr(_local_button+0)
LDR	R2, [R4, #0]
ADDS	R2, R2, #4
LDRB	R3, [R2, #0]
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
STRH	R3, [R2, #0]
;GSM2_driver.c,208 :: 		exec_button = local_button;
MOV	R2, R4
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
STR	R3, [R2, #0]
;GSM2_driver.c,209 :: 		}
L_Get_Object24:
;GSM2_driver.c,210 :: 		}
L_Get_Object23:
;GSM2_driver.c,202 :: 		for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
MOVW	R3, #lo_addr(__object_count+0)
MOVT	R3, #hi_addr(__object_count+0)
LDRSH	R2, [R3, #0]
ADDS	R2, R2, #1
STRH	R2, [R3, #0]
;GSM2_driver.c,211 :: 		}
; Y end address is: 28 (R7)
; X end address is: 32 (R8)
IT	AL
BAL	L_Get_Object20
L_Get_Object21:
;GSM2_driver.c,213 :: 		_object_count = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
;GSM2_driver.c,214 :: 		if (button_order >  _object_count )
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R2, [R2, #0]
CMP	R2, #-1
IT	LE
BLE	L_Get_Object25
;GSM2_driver.c,215 :: 		_object_count = button_order;
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
L_Get_Object25:
;GSM2_driver.c,216 :: 		}
L_end_Get_Object:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Get_Object
GSM2_driver_Process_TP_Press:
;GSM2_driver.c,219 :: 		static void Process_TP_Press(unsigned int X, unsigned int Y) {
; Y start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Y end address is: 4 (R1)
; Y start address is: 4 (R1)
;GSM2_driver.c,220 :: 		exec_button         = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
STR	R3, [R2, #0]
;GSM2_driver.c,222 :: 		Get_Object(X, Y);
; Y end address is: 4 (R1)
BL	_Get_Object+0
;GSM2_driver.c,224 :: 		if (_object_count != -1) {
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, #-1
IT	EQ
BEQ	L_GSM2_driver_Process_TP_Press26
;GSM2_driver.c,225 :: 		if (_object_count == button_order) {
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_GSM2_driver_Process_TP_Press27
;GSM2_driver.c,226 :: 		if (exec_button->Active == 1) {
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
ADDS	R2, #19
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_GSM2_driver_Process_TP_Press28
;GSM2_driver.c,227 :: 		if (exec_button->OnPressPtr != 0) {
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #64
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_GSM2_driver_Process_TP_Press29
;GSM2_driver.c,228 :: 		exec_button->OnPressPtr();
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #64
LDR	R2, [R4, #0]
BLX	R2
;GSM2_driver.c,229 :: 		return;
IT	AL
BAL	L_end_Process_TP_Press
;GSM2_driver.c,230 :: 		}
L_GSM2_driver_Process_TP_Press29:
;GSM2_driver.c,231 :: 		}
L_GSM2_driver_Process_TP_Press28:
;GSM2_driver.c,232 :: 		}
L_GSM2_driver_Process_TP_Press27:
;GSM2_driver.c,234 :: 		}
L_GSM2_driver_Process_TP_Press26:
;GSM2_driver.c,235 :: 		}
L_end_Process_TP_Press:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of GSM2_driver_Process_TP_Press
GSM2_driver_Process_TP_Up:
;GSM2_driver.c,237 :: 		static void Process_TP_Up(unsigned int X, unsigned int Y) {
; Y start address is: 4 (R1)
SUB	SP, SP, #12
STR	LR, [SP, #0]
; Y end address is: 4 (R1)
; Y start address is: 4 (R1)
;GSM2_driver.c,239 :: 		switch (PressedObjectType) {
IT	AL
BAL	L_GSM2_driver_Process_TP_Up30
;GSM2_driver.c,241 :: 		case 0: {
L_GSM2_driver_Process_TP_Up32:
;GSM2_driver.c,242 :: 		if (PressedObject != 0) {
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
LDR	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_GSM2_driver_Process_TP_Up33
;GSM2_driver.c,243 :: 		exec_button = (TButton*)PressedObject;
MOVW	R4, #lo_addr(_PressedObject+0)
MOVT	R4, #hi_addr(_PressedObject+0)
LDR	R3, [R4, #0]
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
STR	R3, [R2, #0]
;GSM2_driver.c,244 :: 		if ((exec_button->PressColEnabled == 1) && (exec_button->OwnerScreen == CurrentScreen)) {
MOV	R2, R4
LDR	R2, [R2, #0]
ADDS	R2, #46
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_GSM2_driver_Process_TP_Up74
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
CMP	R3, R2
IT	NE
BNE	L_GSM2_driver_Process_TP_Up73
L_GSM2_driver_Process_TP_Up72:
;GSM2_driver.c,245 :: 		DrawButton(exec_button);
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
STRH	R1, [SP, #4]
STRH	R0, [SP, #8]
MOV	R0, R2
BL	_DrawButton+0
LDRH	R0, [SP, #8]
LDRH	R1, [SP, #4]
;GSM2_driver.c,244 :: 		if ((exec_button->PressColEnabled == 1) && (exec_button->OwnerScreen == CurrentScreen)) {
L_GSM2_driver_Process_TP_Up74:
L_GSM2_driver_Process_TP_Up73:
;GSM2_driver.c,247 :: 		break;
IT	AL
BAL	L_GSM2_driver_Process_TP_Up31
;GSM2_driver.c,248 :: 		}
L_GSM2_driver_Process_TP_Up33:
;GSM2_driver.c,249 :: 		break;
IT	AL
BAL	L_GSM2_driver_Process_TP_Up31
;GSM2_driver.c,251 :: 		}
L_GSM2_driver_Process_TP_Up30:
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
LDRSH	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_GSM2_driver_Process_TP_Up32
; Y end address is: 4 (R1)
L_GSM2_driver_Process_TP_Up31:
;GSM2_driver.c,254 :: 		Get_Object(X, Y);
; Y start address is: 4 (R1)
; Y end address is: 4 (R1)
BL	_Get_Object+0
;GSM2_driver.c,257 :: 		if (_object_count != -1) {
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, #-1
IT	EQ
BEQ	L_GSM2_driver_Process_TP_Up37
;GSM2_driver.c,259 :: 		if (_object_count == button_order) {
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_GSM2_driver_Process_TP_Up38
;GSM2_driver.c,260 :: 		if (exec_button->Active == 1) {
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
ADDS	R2, #19
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_GSM2_driver_Process_TP_Up39
;GSM2_driver.c,261 :: 		if (exec_button->OnUpPtr != 0)
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #52
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_GSM2_driver_Process_TP_Up40
;GSM2_driver.c,262 :: 		exec_button->OnUpPtr();
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #52
LDR	R2, [R4, #0]
BLX	R2
L_GSM2_driver_Process_TP_Up40:
;GSM2_driver.c,263 :: 		if (PressedObject == (void *)exec_button)
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
LDR	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_GSM2_driver_Process_TP_Up41
;GSM2_driver.c,264 :: 		if (exec_button->OnClickPtr != 0)
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #60
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_GSM2_driver_Process_TP_Up42
;GSM2_driver.c,265 :: 		exec_button->OnClickPtr();
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #60
LDR	R2, [R4, #0]
BLX	R2
L_GSM2_driver_Process_TP_Up42:
L_GSM2_driver_Process_TP_Up41:
;GSM2_driver.c,266 :: 		PressedObject = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;GSM2_driver.c,267 :: 		PressedObjectType = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;GSM2_driver.c,268 :: 		return;
IT	AL
BAL	L_end_Process_TP_Up
;GSM2_driver.c,269 :: 		}
L_GSM2_driver_Process_TP_Up39:
;GSM2_driver.c,270 :: 		}
L_GSM2_driver_Process_TP_Up38:
;GSM2_driver.c,272 :: 		}
L_GSM2_driver_Process_TP_Up37:
;GSM2_driver.c,273 :: 		PressedObject = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;GSM2_driver.c,274 :: 		PressedObjectType = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;GSM2_driver.c,275 :: 		}
L_end_Process_TP_Up:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of GSM2_driver_Process_TP_Up
GSM2_driver_Process_TP_Down:
;GSM2_driver.c,277 :: 		static void Process_TP_Down(unsigned int X, unsigned int Y) {
; Y start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Y end address is: 4 (R1)
; Y start address is: 4 (R1)
;GSM2_driver.c,279 :: 		object_pressed      = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_object_pressed+0)
MOVT	R2, #hi_addr(_object_pressed+0)
STRB	R3, [R2, #0]
;GSM2_driver.c,280 :: 		exec_button         = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
STR	R3, [R2, #0]
;GSM2_driver.c,282 :: 		Get_Object(X, Y);
; Y end address is: 4 (R1)
BL	_Get_Object+0
;GSM2_driver.c,284 :: 		if (_object_count != -1) {
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, #-1
IT	EQ
BEQ	L_GSM2_driver_Process_TP_Down43
;GSM2_driver.c,285 :: 		if (_object_count == button_order) {
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_GSM2_driver_Process_TP_Down44
;GSM2_driver.c,286 :: 		if (exec_button->Active == 1) {
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
ADDS	R2, #19
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_GSM2_driver_Process_TP_Down45
;GSM2_driver.c,287 :: 		if (exec_button->PressColEnabled == 1) {
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
ADDS	R2, #46
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_GSM2_driver_Process_TP_Down46
;GSM2_driver.c,288 :: 		object_pressed = 1;
MOVS	R3, #1
MOVW	R2, #lo_addr(_object_pressed+0)
MOVT	R2, #hi_addr(_object_pressed+0)
STRB	R3, [R2, #0]
;GSM2_driver.c,289 :: 		DrawButton(exec_button);
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
MOV	R0, R2
BL	_DrawButton+0
;GSM2_driver.c,290 :: 		}
L_GSM2_driver_Process_TP_Down46:
;GSM2_driver.c,291 :: 		PressedObject = (void *)exec_button;
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R3, [R4, #0]
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;GSM2_driver.c,292 :: 		PressedObjectType = 0;
MOVS	R3, #0
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;GSM2_driver.c,293 :: 		if (exec_button->OnDownPtr != 0) {
LDR	R4, [R4, #0]
ADDS	R4, #56
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_GSM2_driver_Process_TP_Down47
;GSM2_driver.c,294 :: 		exec_button->OnDownPtr();
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #56
LDR	R2, [R4, #0]
BLX	R2
;GSM2_driver.c,295 :: 		return;
IT	AL
BAL	L_end_Process_TP_Down
;GSM2_driver.c,296 :: 		}
L_GSM2_driver_Process_TP_Down47:
;GSM2_driver.c,297 :: 		}
L_GSM2_driver_Process_TP_Down45:
;GSM2_driver.c,298 :: 		}
L_GSM2_driver_Process_TP_Down44:
;GSM2_driver.c,300 :: 		}
L_GSM2_driver_Process_TP_Down43:
;GSM2_driver.c,301 :: 		}
L_end_Process_TP_Down:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of GSM2_driver_Process_TP_Down
_Check_TP:
;GSM2_driver.c,303 :: 		void Check_TP() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;GSM2_driver.c,304 :: 		if (STMPE610_PressDetect()) {
BL	_STMPE610_PressDetect+0
CMP	R0, #0
IT	EQ
BEQ	L_Check_TP48
;GSM2_driver.c,306 :: 		if (STMPE610_GetLastCoordinates(&Xcoord, &Ycoord) == 0) {
MOVW	R1, #lo_addr(_Ycoord+0)
MOVT	R1, #hi_addr(_Ycoord+0)
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
BL	_STMPE610_GetLastCoordinates+0
CMP	R0, #0
IT	NE
BNE	L_Check_TP49
;GSM2_driver.c,307 :: 		Process_TP_Press(Xcoord, Ycoord);
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
LDRH	R0, [R0, #0]
BL	GSM2_driver_Process_TP_Press+0
;GSM2_driver.c,308 :: 		if (PenDown == 0) {
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_Check_TP50
;GSM2_driver.c,309 :: 		PenDown = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
STRB	R1, [R0, #0]
;GSM2_driver.c,310 :: 		Process_TP_Down(Xcoord, Ycoord);
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
LDRH	R0, [R0, #0]
BL	GSM2_driver_Process_TP_Down+0
;GSM2_driver.c,311 :: 		}
L_Check_TP50:
;GSM2_driver.c,312 :: 		}
L_Check_TP49:
;GSM2_driver.c,313 :: 		}
IT	AL
BAL	L_Check_TP51
L_Check_TP48:
;GSM2_driver.c,314 :: 		else if (PenDown == 1) {
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_Check_TP52
;GSM2_driver.c,315 :: 		PenDown = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
STRB	R1, [R0, #0]
;GSM2_driver.c,316 :: 		Process_TP_Up(Xcoord, Ycoord);
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
LDRH	R0, [R0, #0]
BL	GSM2_driver_Process_TP_Up+0
;GSM2_driver.c,317 :: 		}
L_Check_TP52:
L_Check_TP51:
;GSM2_driver.c,318 :: 		}
L_end_Check_TP:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Check_TP
_Init_MCU:
;GSM2_driver.c,320 :: 		void Init_MCU() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;GSM2_driver.c,324 :: 		GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_6);
MOVW	R1, #64
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;GSM2_driver.c,325 :: 		GPIO_Digital_Input(&GPIOB_BASE, _GPIO_PINMASK_7);
MOVW	R1, #128
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;GSM2_driver.c,326 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
STR	R1, [R0, #0]
;GSM2_driver.c,327 :: 		while (GPIOB_IDR.B7 == 0) {
L_Init_MCU53:
MOVW	R1, #lo_addr(GPIOB_IDR+0)
MOVT	R1, #hi_addr(GPIOB_IDR+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_Init_MCU54
;GSM2_driver.c,328 :: 		GPIOB_ODR.B6 = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
STR	R1, [R0, #0]
;GSM2_driver.c,329 :: 		Delay_us(10);
MOVW	R7, #498
MOVT	R7, #0
NOP
NOP
L_Init_MCU55:
SUBS	R7, R7, #1
BNE	L_Init_MCU55
NOP
NOP
NOP
;GSM2_driver.c,330 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
STR	R1, [R0, #0]
;GSM2_driver.c,331 :: 		Delay_us(10);
MOVW	R7, #498
MOVT	R7, #0
NOP
NOP
L_Init_MCU57:
SUBS	R7, R7, #1
BNE	L_Init_MCU57
NOP
NOP
NOP
;GSM2_driver.c,332 :: 		}
IT	AL
BAL	L_Init_MCU53
L_Init_MCU54:
;GSM2_driver.c,333 :: 		I2C1_Init_Advanced(400000, &_GPIO_MODULE_I2C1_PB67);
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #6784
MOVT	R0, #6
BL	_I2C1_Init_Advanced+0
;GSM2_driver.c,335 :: 		TFT_Set_Default_Mode();
BL	_TFT_Set_Default_Mode+0
;GSM2_driver.c,336 :: 		GPIO_Digital_Output(&GPIOG_BASE, 0x00FF);
MOVS	R1, #255
MOVW	R0, #lo_addr(GPIOG_BASE+0)
MOVT	R0, #hi_addr(GPIOG_BASE+0)
BL	_GPIO_Digital_Output+0
;GSM2_driver.c,337 :: 		GPIO_Digital_Output(&GPIOE_BASE, 0xFF00);
MOVW	R1, #65280
MOVW	R0, #lo_addr(GPIOE_BASE+0)
MOVT	R0, #hi_addr(GPIOE_BASE+0)
BL	_GPIO_Digital_Output+0
;GSM2_driver.c,338 :: 		GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_4);
MOVW	R1, #16
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;GSM2_driver.c,339 :: 		GPIOB_ODR.B4 = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
STR	R1, [R0, #0]
;GSM2_driver.c,340 :: 		TFT_Set_Default_Mode();
BL	_TFT_Set_Default_Mode+0
;GSM2_driver.c,341 :: 		TFT_Set_MM_Plus();
BL	_TFT_Set_MM_Plus+0
;GSM2_driver.c,342 :: 		STMPE610_SetDefaultMode();
BL	_STMPE610_SetDefaultMode+0
;GSM2_driver.c,343 :: 		}
L_end_Init_MCU:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Init_MCU
_STMPE610_Config:
;GSM2_driver.c,345 :: 		char STMPE610_Config() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;GSM2_driver.c,346 :: 		STMPE610_SetI2CAddress(STMPE610_I2C_ADDR1);
MOVS	R0, #136
BL	_STMPE610_SetI2CAddress+0
;GSM2_driver.c,347 :: 		if(STMPE610_IsOperational()) {
BL	_STMPE610_IsOperational+0
CMP	R0, #0
IT	EQ
BEQ	L_STMPE610_Config59
;GSM2_driver.c,348 :: 		return STMPE610_IO_NOT_OPERATIONAL;
MOVS	R0, #4
IT	AL
BAL	L_end_STMPE610_Config
;GSM2_driver.c,349 :: 		}
L_STMPE610_Config59:
;GSM2_driver.c,351 :: 		STMPE610_Reset();
BL	_STMPE610_Reset+0
;GSM2_driver.c,352 :: 		STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
MOVS	R1, #1
MOVS	R0, #3
BL	_STMPE610_Module+0
;GSM2_driver.c,353 :: 		STMPE610_AlternateFunction(STMPE610_GPIO_PIN1, STMPE610_ENABLE);
MOVS	R1, #1
MOVS	R0, #2
BL	_STMPE610_AlternateFunction+0
;GSM2_driver.c,354 :: 		STMPE610_SetGPIOPin(STMPE610_GPIO_PIN1, 0);   // IN1 to "0" -> I2C communication
MOVS	R1, #0
MOVS	R0, #2
BL	_STMPE610_SetGPIOPin+0
;GSM2_driver.c,355 :: 		STMPE610_SetSize(480,272);
MOVW	R1, #272
MOVW	R0, #480
BL	_STMPE610_SetSize+0
;GSM2_driver.c,356 :: 		STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
MOVS	R1, #1
MOVS	R0, #3
BL	_STMPE610_Module+0
;GSM2_driver.c,357 :: 		STMPE610_EnableInterrupt(STMPE610_IE_TOUCH_DET | STMPE610_IE_FIFO_TH | STMPE610_IE_FIFO_0FLOW, STMPE610_ENABLE);
MOVS	R1, #1
MOVS	R0, #7
BL	_STMPE610_EnableInterrupt+0
;GSM2_driver.c,358 :: 		STMPE610_ConfigureInterrupt(STMPE610_INT_POLARITY_ACTIVE_HIGH | STMPE610_INT_TYPE_EDGE | STMPE610_INT_ENABLE_ALL);
MOVS	R0, #7
BL	_STMPE610_ConfigureInterrupt+0
;GSM2_driver.c,359 :: 		STMPE610_SetADC(STMPE610_ADC_CTRL1_SAMPLETIME_44 | STMPE610_ADC_CTRL1_ADC_12BIT | STMPE610_ADC_CTRL1_INT_REFERENCE);
MOVS	R0, #20
BL	_STMPE610_SetADC+0
;GSM2_driver.c,360 :: 		Delay_10ms(); Delay_10ms();
BL	_Delay_10ms+0
BL	_Delay_10ms+0
;GSM2_driver.c,361 :: 		STMPE610_SetADCClock(STMPE610_ADC_CTRL2_3250_kHZ);
MOVS	R0, #1
BL	_STMPE610_SetADCClock+0
;GSM2_driver.c,362 :: 		STMPE610_AlternateFunction(STMPE610_GPIO_PIN4 | STMPE610_GPIO_PIN5 | STMPE610_GPIO_PIN6 | STMPE610_GPIO_PIN7, STMPE610_DISABLE);
MOVS	R1, #0
MOVS	R0, #240
BL	_STMPE610_AlternateFunction+0
;GSM2_driver.c,363 :: 		STMPE610_ConfigureTSC(STMPE610_TSC_CFG_AVE_CTRL_4S, STMPE610_TSC_CFG_TOUCH_DET_DELAY_500uS, STMPE610_TSC_CFG_TOUCH_SETTLING_500uS);
MOVS	R2, #2
MOVS	R1, #24
MOVS	R0, #128
BL	_STMPE610_ConfigureTSC+0
;GSM2_driver.c,364 :: 		STMPE610_SetFIFOThreshold(1);
MOVS	R0, #1
BL	_STMPE610_SetFIFOThreshold+0
;GSM2_driver.c,365 :: 		STMPE610_ResetFIFO();
BL	_STMPE610_ResetFIFO+0
;GSM2_driver.c,366 :: 		STMPE610_TSIDrive(STMPE610_TSC_I_DRIVE_20mA);
MOVS	R0, #0
BL	_STMPE610_TSIDrive+0
;GSM2_driver.c,367 :: 		STMPE610_TSControl(STMPE610_TSC_CTRL_TRACK0 | STMPE610_TSC_CTRL_ACQU_XYZ | STMPE610_TSC_CTRL_ENABLE);
MOVS	R0, #1
BL	_STMPE610_TSControl+0
;GSM2_driver.c,368 :: 		STMPE610_ZDataFraction(STMPE610_FRACP4_WHOLP4);
MOVS	R0, #4
BL	_STMPE610_ZDataFraction+0
;GSM2_driver.c,369 :: 		STMPE610_SetTouchPressureThreshold(45);
MOVS	R0, #45
BL	_STMPE610_SetTouchPressureThreshold+0
;GSM2_driver.c,370 :: 		STMPE610_ClearInterrupts();
BL	_STMPE610_ClearInterrupts+0
;GSM2_driver.c,371 :: 		STMPE610_WriteReg(STMPE610_INT_CTRL_REG, 0x01);
MOVS	R1, #1
MOVS	R0, #9
BL	_STMPE610_WriteReg+0
;GSM2_driver.c,372 :: 		return STMPE610_OK;
MOVS	R0, #0
;GSM2_driver.c,373 :: 		}
L_end_STMPE610_Config:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STMPE610_Config
_Start_TP:
;GSM2_driver.c,376 :: 		void Start_TP() {
SUB	SP, SP, #16
STR	LR, [SP, #0]
;GSM2_driver.c,378 :: 		Init_MCU();
BL	_Init_MCU+0
;GSM2_driver.c,380 :: 		InitializeTouchPanel();
BL	GSM2_driver_InitializeTouchPanel+0
;GSM2_driver.c,381 :: 		if (STMPE610_Config() == STMPE610_OK) {
BL	_STMPE610_Config+0
CMP	R0, #0
IT	NE
BNE	L_Start_TP60
;GSM2_driver.c,382 :: 		} else {
IT	AL
BAL	L_Start_TP61
L_Start_TP60:
;GSM2_driver.c,383 :: 		while(1);
L_Start_TP62:
IT	AL
BAL	L_Start_TP62
;GSM2_driver.c,384 :: 		}
L_Start_TP61:
;GSM2_driver.c,388 :: 		TPConstsStruct.X_Min = 105;
MOVS	R0, #105
STRH	R0, [SP, #4]
;GSM2_driver.c,389 :: 		TPConstsStruct.X_Max = 3925;
MOVW	R0, #3925
STRH	R0, [SP, #6]
;GSM2_driver.c,390 :: 		TPConstsStruct.Y_Min = 250;
MOVS	R0, #250
STRH	R0, [SP, #8]
;GSM2_driver.c,391 :: 		TPConstsStruct.Y_Max = 3820;
MOVW	R0, #3820
STRH	R0, [SP, #10]
;GSM2_driver.c,392 :: 		TPConstsStruct.Rotate = 0;
MOVS	R0, #0
STRB	R0, [SP, #12]
;GSM2_driver.c,393 :: 		STMPE610_SetCalibrationConsts(&TPConstsStruct);
ADD	R0, SP, #4
BL	_STMPE610_SetCalibrationConsts+0
;GSM2_driver.c,395 :: 		InitializeObjects();
BL	GSM2_driver_InitializeObjects+0
;GSM2_driver.c,396 :: 		display_width = Screen1.Width;
MOVW	R0, #lo_addr(_Screen1+2)
MOVT	R0, #hi_addr(_Screen1+2)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_display_width+0)
MOVT	R0, #hi_addr(_display_width+0)
STRH	R1, [R0, #0]
;GSM2_driver.c,397 :: 		display_height = Screen1.Height;
MOVW	R0, #lo_addr(_Screen1+4)
MOVT	R0, #hi_addr(_Screen1+4)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_display_height+0)
MOVT	R0, #hi_addr(_display_height+0)
STRH	R1, [R0, #0]
;GSM2_driver.c,398 :: 		DrawScreen(&Screen1);
MOVW	R0, #lo_addr(_Screen1+0)
MOVT	R0, #hi_addr(_Screen1+0)
BL	_DrawScreen+0
;GSM2_driver.c,399 :: 		}
L_end_Start_TP:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _Start_TP
GSM2_driver____?ag:
L_end_GSM2_driver___?ag:
BX	LR
; end of GSM2_driver____?ag
