/**************************************************************************************************
  UART2.h
**************************************************************************************************/
#ifndef UART2_H
#define UART2_H


// Defines
#define U2_RcvBufSize 256   // Number of bytes in Receive Buffer
#define U2_rxqsize 256      // Number of characters in receive buffer queue
#define U2_txqsize 64       // Number of pointers in transmit queue



//typedef void (*tPointerFcn)(void);  // Pointer to a function




// Function Prototypes
void UART2_SetBaud(void);
void UART2_StartRx(void);
void UART2_StartTx(void);

void UART2_Initialize(void);

void UART2_RxQueueInit(void);
char UART2_GetChar(char *rxbyte);

void UART2_Rx(void);
void UART2_Rx1(void);
void UART2_Rx2(void);


void UART2_TxQueueInit(void);
void UART2_PutQueue(char *msg);

void UART2_SendMsg(char *s);
void UART2_CheckQueue(void);




#endif